include particle.e

global constant BOOM_SIZE = 20

global constant
	B_TYPE=1,
	B_ID=2,
	B_FLOATING=3,
	B_BOOM=4,
	new_block={0,0,0,{}}
	

global function block(integer the_type)
	return {the_type,0,0,{}}
end function


-- This prepares a block to be exploded when it is removed
global function setup_exploding_block(sequence block,integer x,integer y)
	integer c
	sequence boom,pc
	
	-- Mark the block as "dead"
	c = block[B_TYPE]-16
	if c>=1 then
		pc = possible_colors[c][1..3]
	else
		pc = {0,0,0}
	end if
	boom = repeat(new_particle,BOOM_SIZE)
	
	-- Set up all the particles 
	for i=1 to BOOM_SIZE do
		boom[i][ALIVE] = (c>=1)
		boom[i][LIFE] = 1.0
		boom[i][FADE] = (rand(100)/800.0)+0.008
		boom[i][POS] = {(x-1) - 4.5,
				9 - (y-1),
				0.0}
		boom[i][DIR] = {(rand(60)-32.0)*1.4,
				rand(50) * -2.25,
				rand(20) * -1.25}
		boom[i][GRAVITY] = {0.0,-0.8,0.0}
		boom[i][COL] = pc
	end for
	
	block[B_BOOM] = boom
	
	return block
end function


-- Draw one row (10) exploding blocks. Return true if there are no live
-- particles left.
global function draw_exploding_blocks(sequence blocks)
	integer explosions
	sequence s
	
	explosions = 0
	
	c_proc(glDisable,{GL_DEPTH_TEST})
	for x=1 to 10 do
		s = draw_particles(blocks[x][B_BOOM], BOOM_SIZE, prttex, -1, 500, 0.4, 0.3, bury_id)
		explosions = explosions or s[1]
		blocks[x][B_BOOM] = s[2]
	end for
	c_proc(glEnable,{GL_DEPTH_TEST})

	return {(explosions=0),blocks}
end function
