include file.e
include get.e
include machine.e
without warning


global constant
	BMPfileError = 1,
        BMPformatError = 2,
        BMPbitCountError = 3,

	BMPErrors = {"Couldn't open file",
	             "Uncorrect header in file",
	             "Unsupported bitcount in file"},
	             
	POINTER = 1,
	WIDTH = 2,
	HEIGHT = 3,
	BITCOUNT = 4
	

constant
	BMPFILEHEADER = {0,0,0,0,0},
	BMPINFOHEADER = repeat(0,11),
	
	OFFBITS = 5,
	BISIZE = 1,
	BIWIDTH = 2,
	BIHEIGHT = 3,
	BIBITCOUNT = 5


integer crap,diffr,bpr,numColors,BMPVersion,bmpChar
atom bmpFn,bmpMem
sequence head,bmpImg,pal,buffert,fileHeader,infoHeader




function peek3(atom src)
	atom ret
 	ret = peek4u(src)
 	return and_bits(src,#00FFFFFF)
end function


-- Reads a 24-bit BMP into memory 
function read24bit()		
 	bmpMem = allocate(infoHeader[BIWIDTH]*infoHeader[BIHEIGHT]*3)	-- allocate memory for the image 
 	if bmpMem<=0 then
 		return {0}
 	end if
 	crap = seek(bmpFn,fileHeader[OFFBITS])				-- jump to start of image data 
 	diffr = (bpr-(infoHeader[BIWIDTH]*3))
 	for i=1 to infoHeader[BIHEIGHT] do				-- height of bitmap in pixels 
  		for j=1 to infoHeader[BIWIDTH] do			-- width of bitmap in pixels 
   			for k=1 to 3 do
    				bmpChar = getc(bmpFn)
    				-- BMPs are stored upside down, hence the complex formula 
    				poke((bmpMem + (infoHeader[BIWIDTH]*infoHeader[BIHEIGHT]*3)-1) - 
    				      (i*infoHeader[BIWIDTH]*3)+((j-1)*3)+(4-k), bmpChar)
   			end for
  		end for
  		if diffr>0 then
   			for k=1 to diffr do
    				bmpChar = getc(bmpFn)
   			end for
  		end if
 	end for
 	bmpImg = {bmpMem,infoHeader[BIWIDTH],infoHeader[BIHEIGHT],24}	-- return-data 
 	return bmpImg
end function




-- Reads the BMP headers and calls read24bit() 
global function load_bmp(sequence filename)
	sequence s
	
 	head = repeat(0,56)
 	bmpFn = open(filename,"rb")
 	if bmpFn=-1 then
 		return {0}
	end if
	s = get_bytes(bmpFn,14)
	if not equal(s[1..2],"BM") then
		close(bmpFn)
		return {0}
	end if
	fileHeader = BMPFILEHEADER
	infoHeader = BMPINFOHEADER
	fileHeader[OFFBITS] = bytes_to_int(s[11..14])
	infoHeader[BISIZE] = bytes_to_int(get_bytes(bmpFn,4))
	if infoHeader[BISIZE] != 40 then
		close(bmpFn)
		return {0}
	end if
	s = get_bytes(bmpFn,infoHeader[BISIZE]-4)
	infoHeader[BIWIDTH] = bytes_to_int(s[1..4])
	infoHeader[BIHEIGHT] = bytes_to_int(s[5..8])
	infoHeader[BIBITCOUNT] = bytes_to_int(s[11..12]&{0,0})
	
	
	bpr = floor(((infoHeader[BIBITCOUNT] * infoHeader[BIWIDTH])+31)/32)*4

   	if infoHeader[BIBITCOUNT]=24 then
    		s = read24bit()
    		close(bmpFn)
    		return s
    	end if
    	
    	close(bmpFn)
    	return {0}
end function


-- Add an alpha channel to a 24-bit bitmap. All pixels that match (r,g,b) are
-- given an alpha value of zero, while other pixels are given full alpha.
global function add_alpha_channel(sequence img,sequence rgb)
	atom new_lpbits,src,dst

	-- This is only valid for 24-bit images
	if img[BITCOUNT] != 24 then
		return img
	end if

	-- Allocate space for the image data
	new_lpbits = allocate(img[WIDTH]*img[HEIGHT]*4)
	if new_lpbits<=0 then
		return {0}
	end if
	
	src = img[POINTER]
	dst = new_lpbits

	for i=0 to img[HEIGHT]-1 do
		for j=0 to img[WIDTH]-1 do
			if (rgb[1]=peek(src)) and (rgb[2]=peek(src+1)) and (rgb[3]=peek(src+2)) then
				poke(dst+3,0)
			else
				poke(dst+3,255)
			end if
			poke(dst,peek({src,3}))
			src += 3
			dst += 4
		end for
	end for

	free(img[POINTER])
	return {new_lpbits,img[WIDTH],img[HEIGHT],32}
end function

