include texture.e


global function font(sequence filename)
	return texture({filename,0,0,0})
end function



-- Print 'text' at (x,y,z) with the given size and spacing
global procedure putsxyz(sequence text,integer f,sequence pos,integer src_width,sequence size,atom char_spacing)
	integer c
	atom s,t,x,y,z
	atom cellSize,dst_width,dst_height
	
	cellSize = 0.05859375
	dst_width = size[1]
	dst_height = size[2]

	c_proc(glEnable,{GL_TEXTURE_2D})
	c_proc(glBindTexture,{GL_TEXTURE_2D,f})
	c_proc(glEnable,{GL_BLEND})
	c_proc(glBlendFunc,{GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA})

	
	-- Loop until max_len characters have been printed, or a null terminator
	-- is found.
	for i=1 to length(text) do
		c = text[i]
		if c != ' ' then	-- Don't print the space character
			c -= ' '
			--c += charset
			s = and_bits(c,15)*16
			t = and_bits(c,#F0)
			s /= 256.0 
			t /= 256.0
			x = pos[1]
			y = pos[2]
			z = pos[3]
			c_proc(glBegin,{GL_QUADS})
				c_proc(glTexCoord2f,{s, t})
				c_proc(glVertex3f,pos)
				c_proc(glTexCoord2f,{s, t+cellSize})
				c_proc(glVertex3f,{x, y - dst_height, z})
				c_proc(glTexCoord2f,{s + cellSize, t + cellSize})
				c_proc(glVertex3f,{x + dst_width,y - dst_height, z})
				c_proc(glTexCoord2f,{s + cellSize, t})
				c_proc(glVertex3f,{x + dst_width, y, z})
			c_proc(glEnd,{})
		end if
		pos[1] += char_spacing
	end for
end procedure
