--
-- Copyright 1992-1997 Silicon Graphics, Inc.
-- All Rights Reserved.
--
-- This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
-- the contents of this file may not be disclosed to third parties, copied or
-- duplicated in any form, in whole or in part, without the prior written
-- permission of Silicon Graphics, Inc.
--
-- RESTRICTED RIGHTS LEGEND:
-- Use, duplication or disclosure by the Government is subject to restrictions
-- as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
-- and Computer Software clause at DFARS 252.227-7013, and/or in similar or
-- successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
-- rights reserved under the Copyright Laws of the United States.
--


-- Euphoria version by Mic, 000304
--
-- Glue-specific version, 000314
-- Updated version, 000704
-- Updated version, 030126



include machine.e
include dll.e
include get.e
include validate.e


global constant GL_LIBPATH = "/usr/X11R6/lib/"


--define some GL types
global constant GLbyte		= C_CHAR,
		GLubyte		= C_UCHAR,
		GLshort		= C_SHORT,
		GLushort 	= C_USHORT,	
		GLenum 		= C_UINT,
		GLint  		= C_INT,
		GLuint		= C_UINT,
		GLsizei		= C_INT,
		GLbitfield 	= C_UINT,
		GLfloat		= C_FLOAT,
		GLclampf	= C_FLOAT,
		GLdouble 	= C_DOUBLE
--/GL types


--************** Define OpenGL constants ****************

-- Extensions 
global constant GL_VERSION_1_1 = 1 
global constant GL_EXT_abgr = 1 
global constant GL_EXT_bgra = 1 
global constant GL_EXT_packed_pixels = 1 
global constant GL_EXT_paletted_texture = 1 
global constant GL_EXT_vertex_array = 1 
global constant GL_SGI_compiled_vertex_array = 1 
global constant GL_SGI_cull_vertex = 1 
global constant GL_SGI_index_array_formats = 1 
global constant GL_SGI_index_func = 1 
global constant GL_SGI_index_material = 1 
global constant GL_SGI_index_texture = 1 
global constant GL_WIN_swap_hint = 1 

-- AttribMask 
global constant GL_CURRENT_BIT = #00000001 
global constant GL_POINT_BIT = #00000002 
global constant GL_LINE_BIT = #00000004 
global constant GL_POLYGON_BIT = #00000008 
global constant GL_POLYGON_STIPPLE_BIT = #00000010 
global constant GL_PIXEL_MODE_BIT = #00000020 
global constant GL_LIGHTING_BIT = #00000040 
global constant GL_FOG_BIT = #00000080 
global constant GL_DEPTH_BUFFER_BIT = #00000100 
global constant GL_ACCUM_BUFFER_BIT = #00000200 
global constant GL_STENCIL_BUFFER_BIT = #00000400 
global constant GL_VIEWPORT_BIT = #00000800 
global constant GL_TRANSFORM_BIT = #00001000 
global constant GL_ENABLE_BIT = #00002000 
global constant GL_COLOR_BUFFER_BIT = #00004000 
global constant GL_HINT_BIT = #00008000 
global constant GL_EVAL_BIT = #00010000 
global constant GL_LIST_BIT = #00020000 
global constant GL_TEXTURE_BIT = #00040000 
global constant GL_SCISSOR_BIT = #00080000 
global constant GL_ALL_ATTRIB_BITS = #000FFFFF 

-- ClearBufferMask 
--      GL_COLOR_BUFFER_BIT 
--      GL_ACCUM_BUFFER_BIT 
--      GL_STENCIL_BUFFER_BIT 
--      GL_DEPTH_BUFFER_BIT 

-- ClientAttribMask 
global constant GL_CLIENT_PIXEL_STORE_BIT = #00000001 
global constant GL_CLIENT_VERTEX_ARRAY_BIT = #00000002 
global constant GL_CLIENT_ALL_ATTRIB_BITS = #FFFFFFFF 

-- Boolean 
global constant GL_FALSE = 0 
global constant GL_TRUE = 1 

-- BeginMode 
global constant GL_POINTS = #0000 
global constant GL_LINES = #0001 
global constant GL_LINE_LOOP = #0002 
global constant GL_LINE_STRIP = #0003 
global constant GL_TRIANGLES = #0004 
global constant GL_TRIANGLE_STRIP = #0005 
global constant GL_TRIANGLE_FAN = #0006 
global constant GL_QUADS = #0007 
global constant GL_QUAD_STRIP = #0008 
global constant GL_POLYGON = #0009 

-- AccumOp 
global constant GL_ACCUM = #0100 
global constant GL_LOAD = #0101 
global constant GL_RETURN = #0102 
global constant GL_MULT = #0103 
global constant GL_ADD = #0104 

-- AlphaFunction 
global constant GL_NEVER = #0200 
global constant GL_LESS = #0201 
global constant GL_EQUAL = #0202 
global constant GL_LEQUAL = #0203 
global constant GL_GREATER = #0204 
global constant GL_NOTEQUAL = #0205 
global constant GL_GEQUAL = #0206 
global constant GL_ALWAYS = #0207 

-- BlendingFactorDest 
global constant GL_ZERO = 0 
global constant GL_ONE = 1 
global constant GL_SRC_COLOR = #0300 
global constant GL_ONE_MINUS_SRC_COLOR = #0301 
global constant GL_SRC_ALPHA = #0302 
global constant GL_ONE_MINUS_SRC_ALPHA = #0303 
global constant GL_DST_ALPHA = #0304 
global constant GL_ONE_MINUS_DST_ALPHA = #0305 

-- BlendingFactorSrc 
--      GL_ZERO 
--      GL_ONE 
global constant GL_DST_COLOR = #0306 
global constant GL_ONE_MINUS_DST_COLOR = #0307 
global constant GL_SRC_ALPHA_SATURATE = #0308 
--      GL_SRC_ALPHA 
--      GL_ONE_MINUS_SRC_ALPHA 
--      GL_DST_ALPHA 
--      GL_ONE_MINUS_DST_ALPHA 

-- ColorMaterialFace 
--      GL_FRONT 
--      GL_BACK 
--      GL_FRONT_AND_BACK 

-- ColorMaterialParameter 
--      GL_AMBIENT 
--      GL_DIFFUSE 
--      GL_SPECULAR 
--      GL_EMISSION 
--      GL_AMBIENT_AND_DIFFUSE 

-- ColorPointerType 
--      GL_BYTE 
--      GL_UNSIGNED_BYTE 
--      GL_SHORT 
--      GL_UNSIGNED_SHORT 
--      GL_INT 
--      GL_UNSIGNED_INT 
--      GL_FLOAT 
--      GL_DOUBLE 

-- CullFaceMode 
--      GL_FRONT 
--      GL_BACK 
--      GL_FRONT_AND_BACK 

-- CullParameterSGI 
--      GL_CULL_VERTEX_EYE_POSITION_SGI 
--      GL_CULL_VERTEX_OBJECT_POSITION_SGI 

-- DepthFunction 
--      GL_NEVER 
--      GL_LESS 
--      GL_EQUAL 
--      GL_LEQUAL 
--      GL_GREATER 
--      GL_NOTEQUAL 
--      GL_GEQUAL 
--      GL_ALWAYS 

-- DrawBufferMode 
global constant GL_NONE = 0 
global constant GL_FRONT_LEFT = #0400 
global constant GL_FRONT_RIGHT = #0401 
global constant GL_BACK_LEFT = #0402 
global constant GL_BACK_RIGHT = #0403 
global constant GL_FRONT = #0404 
global constant GL_BACK = #0405 
global constant GL_LEFT = #0406 
global constant GL_RIGHT = #0407 
global constant GL_FRONT_AND_BACK = #0408 
global constant GL_AUX0 = #0409 
global constant GL_AUX1 = #040A 
global constant GL_AUX2 = #040B 
global constant GL_AUX3 = #040C 

-- EnableCap 
--      GL_FOG 
--      GL_LIGHTING 
--      GL_TEXTURE_1D 
--      GL_TEXTURE_2D 
--      GL_LINE_STIPPLE 
--      GL_POLYGON_STIPPLE 
--      GL_CULL_FACE 
--      GL_ALPHA_TEST 
--      GL_BLEND 
--      GL_INDEX_LOGIC_OP 
--      GL_COLOR_LOGIC_OP 
--      GL_DITHER 
--      GL_STENCIL_TEST 
--      GL_DEPTH_TEST 
--      GL_CLIP_PLANE0 
--      GL_CLIP_PLANE1 
--      GL_CLIP_PLANE2 
--      GL_CLIP_PLANE3 
--      GL_CLIP_PLANE4 
--      GL_CLIP_PLANE5 
--      GL_LIGHT0 
--      GL_LIGHT1 
--      GL_LIGHT2 
--      GL_LIGHT3 
--      GL_LIGHT4 
--      GL_LIGHT5 
--      GL_LIGHT6 
--      GL_LIGHT7 
--      GL_TEXTURE_GEN_S 
--      GL_TEXTURE_GEN_T 
--      GL_TEXTURE_GEN_R 
--      GL_TEXTURE_GEN_Q 
--      GL_MAP1_VERTEX_3 
--      GL_MAP1_VERTEX_4 
--      GL_MAP1_COLOR_4 
--      GL_MAP1_INDEX 
--      GL_MAP1_NORMAL 
--      GL_MAP1_TEXTURE_COORD_1 
--      GL_MAP1_TEXTURE_COORD_2 
--      GL_MAP1_TEXTURE_COORD_3 
--      GL_MAP1_TEXTURE_COORD_4 
--      GL_MAP2_VERTEX_3 
--      GL_MAP2_VERTEX_4 
--      GL_MAP2_COLOR_4 
--      GL_MAP2_INDEX 
--      GL_MAP2_NORMAL 
--      GL_MAP2_TEXTURE_COORD_1 
--      GL_MAP2_TEXTURE_COORD_2 
--      GL_MAP2_TEXTURE_COORD_3 
--      GL_MAP2_TEXTURE_COORD_4 
--      GL_POINT_SMOOTH 
--      GL_LINE_SMOOTH 
--      GL_POLYGON_SMOOTH 
--      GL_SCISSOR_TEST 
--      GL_COLOR_MATERIAL 
--      GL_NORMALIZE 
--      GL_AUTO_NORMAL 
--      GL_POLYGON_OFFSET_POINT 
--      GL_POLYGON_OFFSET_LINE 
--      GL_POLYGON_OFFSET_FILL 
--      GL_VERTEX_ARRAY 
--      GL_NORMAL_ARRAY 
--      GL_COLOR_ARRAY 
--      GL_INDEX_ARRAY 
--      GL_TEXTURE_COORD_ARRAY 
--      GL_EDGE_FLAG_ARRAY 
--      GL_CULL_VERTEX_SGI 
--      GL_INDEX_MATERIAL_SGI 
--      GL_INDEX_TEST_SGI 

-- ErrorCode 
global constant GL_NO_ERROR = 0 
global constant GL_INVALID_ENUM = #0500 
global constant GL_INVALID_VALUE = #0501 
global constant GL_INVALID_OPERATION = #0502 
global constant GL_STACK_OVERFLOW = #0503 
global constant GL_STACK_UNDERFLOW = #0504 
global constant GL_OUT_OF_MEMORY = #0505 
--      GL_TABLE_TOO_LARGE_EXT 

-- FeedbackType 
global constant GL_2D = #0600 
global constant GL_3D = #0601 
global constant GL_3D_COLOR = #0602 
global constant GL_3D_COLOR_TEXTURE = #0603 
global constant GL_4D_COLOR_TEXTURE = #0604 

-- FeedBackToken 
global constant GL_PASS_THROUGH_TOKEN = #0700 
global constant GL_POINT_TOKEN = #0701 
global constant GL_LINE_TOKEN = #0702 
global constant GL_POLYGON_TOKEN = #0703 
global constant GL_BITMAP_TOKEN = #0704 
global constant GL_DRAW_PIXEL_TOKEN = #0705 
global constant GL_COPY_PIXEL_TOKEN = #0706 
global constant GL_LINE_RESET_TOKEN = #0707 

-- FogMode 
--      GL_LINEAR 
global constant GL_EXP = #0800 
global constant GL_EXP2 = #0801 

-- FogParameter 
--      GL_FOG_COLOR 
--      GL_FOG_DENSITY 
--      GL_FOG_END 
--      GL_FOG_INDEX 
--      GL_FOG_MODE 
--      GL_FOG_START 

-- FrontFaceDirection 
global constant GL_CW = #0900 
global constant GL_CCW = #0901 

-- GetColorTableParameterPNameEXT 
--      GL_COLOR_TABLE_FORMAT_EXT 
--      GL_COLOR_TABLE_WIDTH_EXT 
--      GL_COLOR_TABLE_RED_SIZE_EXT 
--      GL_COLOR_TABLE_GREEN_SIZE_EXT 
--      GL_COLOR_TABLE_BLUE_SIZE_EXT 
--      GL_COLOR_TABLE_ALPHA_SIZE_EXT 
--      GL_COLOR_TABLE_LUMINANCE_SIZE_EXT 
--      GL_COLOR_TABLE_INTENSITY_SIZE_EXT 

-- GetMapQuery 
global constant GL_COEFF = #0A00 
global constant GL_ORDER = #0A01 
global constant GL_DOMAIN = #0A02 

-- GetPixelMap 
global constant GL_PIXEL_MAP_I_TO_I = #0C70 
global constant GL_PIXEL_MAP_S_TO_S = #0C71 
global constant GL_PIXEL_MAP_I_TO_R = #0C72 
global constant GL_PIXEL_MAP_I_TO_G = #0C73 
global constant GL_PIXEL_MAP_I_TO_B = #0C74 
global constant GL_PIXEL_MAP_I_TO_A = #0C75 
global constant GL_PIXEL_MAP_R_TO_R = #0C76 
global constant GL_PIXEL_MAP_G_TO_G = #0C77 
global constant GL_PIXEL_MAP_B_TO_B = #0C78 
global constant GL_PIXEL_MAP_A_TO_A = #0C79 

-- GetPointervPName 
global constant GL_VERTEX_ARRAY_POINTER = #808E 
global constant GL_NORMAL_ARRAY_POINTER = #808F 
global constant GL_COLOR_ARRAY_POINTER = #8090 
global constant GL_INDEX_ARRAY_POINTER = #8091 
global constant GL_TEXTURE_COORD_ARRAY_POINTER = #8092 
global constant GL_EDGE_FLAG_ARRAY_POINTER = #8093 

-- GetPName 
global constant GL_CURRENT_COLOR = #0B00 
global constant GL_CURRENT_INDEX = #0B01 
global constant GL_CURRENT_NORMAL = #0B02 
global constant GL_CURRENT_TEXTURE_COORDS = #0B03 
global constant GL_CURRENT_RASTER_COLOR = #0B04 
global constant GL_CURRENT_RASTER_INDEX = #0B05 
global constant GL_CURRENT_RASTER_TEXTURE_COORDS = #0B06 
global constant GL_CURRENT_RASTER_POSITION = #0B07 
global constant GL_CURRENT_RASTER_POSITION_VALID = #0B08 
global constant GL_CURRENT_RASTER_DISTANCE = #0B09 
global constant GL_POINT_SMOOTH = #0B10 
global constant GL_POINT_SIZE = #0B11 
global constant GL_POINT_SIZE_RANGE = #0B12 
global constant GL_POINT_SIZE_GRANULARITY = #0B13 
global constant GL_LINE_SMOOTH = #0B20 
global constant GL_LINE_WIDTH = #0B21 
global constant GL_LINE_WIDTH_RANGE = #0B22 
global constant GL_LINE_WIDTH_GRANULARITY = #0B23 
global constant GL_LINE_STIPPLE = #0B24 
global constant GL_LINE_STIPPLE_PATTERN = #0B25 
global constant GL_LINE_STIPPLE_REPEAT = #0B26 
global constant GL_LIST_MODE = #0B30 
global constant GL_MAX_LIST_NESTING = #0B31 
global constant GL_LIST_BASE = #0B32 
global constant GL_LIST_INDEX = #0B33 
global constant GL_POLYGON_MODE = #0B40 
global constant GL_POLYGON_SMOOTH = #0B41 
global constant GL_POLYGON_STIPPLE = #0B42 
global constant GL_EDGE_FLAG = #0B43 
global constant GL_CULL_FACE = #0B44 
global constant GL_CULL_FACE_MODE = #0B45 
global constant GL_FRONT_FACE = #0B46 
global constant GL_LIGHTING = #0B50 
global constant GL_LIGHT_MODEL_LOCAL_VIEWER = #0B51 
global constant GL_LIGHT_MODEL_TWO_SIDE = #0B52 
global constant GL_LIGHT_MODEL_AMBIENT = #0B53 
global constant GL_SHADE_MODEL = #0B54 
global constant GL_COLOR_MATERIAL_FACE = #0B55 
global constant GL_COLOR_MATERIAL_PARAMETER = #0B56 
global constant GL_COLOR_MATERIAL = #0B57 
global constant GL_FOG = #0B60 
global constant GL_FOG_INDEX = #0B61 
global constant GL_FOG_DENSITY = #0B62 
global constant GL_FOG_START = #0B63 
global constant GL_FOG_END = #0B64 
global constant GL_FOG_MODE = #0B65 
global constant GL_FOG_COLOR = #0B66 
global constant GL_DEPTH_RANGE = #0B70 
global constant GL_DEPTH_TEST = #0B71 
global constant GL_DEPTH_WRITEMASK = #0B72 
global constant GL_DEPTH_CLEAR_VALUE = #0B73 
global constant GL_DEPTH_FUNC = #0B74 
global constant GL_ACCUM_CLEAR_VALUE = #0B80 
global constant GL_STENCIL_TEST = #0B90 
global constant GL_STENCIL_CLEAR_VALUE = #0B91 
global constant GL_STENCIL_FUNC = #0B92 
global constant GL_STENCIL_VALUE_MASK = #0B93 
global constant GL_STENCIL_FAIL = #0B94 
global constant GL_STENCIL_PASS_DEPTH_FAIL = #0B95 
global constant GL_STENCIL_PASS_DEPTH_PASS = #0B96 
global constant GL_STENCIL_REF = #0B97 
global constant GL_STENCIL_WRITEMASK = #0B98 
global constant GL_MATRIX_MODE = #0BA0 
global constant GL_NORMALIZE = #0BA1 
global constant GL_VIEWPORT = #0BA2 
global constant GL_MODELVIEW_STACK_DEPTH = #0BA3 
global constant GL_PROJECTION_STACK_DEPTH = #0BA4 
global constant GL_TEXTURE_STACK_DEPTH = #0BA5 
global constant GL_MODELVIEW_MATRIX = #0BA6 
global constant GL_PROJECTION_MATRIX = #0BA7 
global constant GL_TEXTURE_MATRIX = #0BA8 
global constant GL_ATTRIB_STACK_DEPTH = #0BB0 
global constant GL_CLIENT_ATTRIB_STACK_DEPTH = #0BB1 
global constant GL_ALPHA_TEST = #0BC0 
global constant GL_ALPHA_TEST_FUNC = #0BC1 
global constant GL_ALPHA_TEST_REF = #0BC2 
global constant GL_DITHER = #0BD0 
global constant GL_BLEND_DST = #0BE0 
global constant GL_BLEND_SRC = #0BE1 
global constant GL_BLEND = #0BE2 
global constant GL_LOGIC_OP_MODE = #0BF0 
global constant GL_INDEX_LOGIC_OP = #0BF1 
global constant GL_LOGIC_OP = GL_INDEX_LOGIC_OP 
global constant GL_COLOR_LOGIC_OP = #0BF2 
global constant GL_AUX_BUFFERS = #0C00 
global constant GL_DRAW_BUFFER = #0C01 
global constant GL_READ_BUFFER = #0C02 
global constant GL_SCISSOR_BOX = #0C10 
global constant GL_SCISSOR_TEST = #0C11 
global constant GL_INDEX_CLEAR_VALUE = #0C20 
global constant GL_INDEX_WRITEMASK = #0C21 
global constant GL_COLOR_CLEAR_VALUE = #0C22 
global constant GL_COLOR_WRITEMASK = #0C23 
global constant GL_INDEX_MODE = #0C30 
global constant GL_RGBA_MODE = #0C31 
global constant GL_DOUBLEBUFFER = #0C32 
global constant GL_STEREO = #0C33 
global constant GL_RENDER_MODE = #0C40 
global constant GL_PERSPECTIVE_CORRECTION_HINT = #0C50 
global constant GL_POINT_SMOOTH_HINT = #0C51 
global constant GL_LINE_SMOOTH_HINT = #0C52 
global constant GL_POLYGON_SMOOTH_HINT = #0C53 
global constant GL_FOG_HINT = #0C54 
global constant GL_TEXTURE_GEN_S = #0C60 
global constant GL_TEXTURE_GEN_T = #0C61 
global constant GL_TEXTURE_GEN_R = #0C62 
global constant GL_TEXTURE_GEN_Q = #0C63 
global constant GL_PIXEL_MAP_I_TO_I_SIZE = #0CB0 
global constant GL_PIXEL_MAP_S_TO_S_SIZE = #0CB1 
global constant GL_PIXEL_MAP_I_TO_R_SIZE = #0CB2 
global constant GL_PIXEL_MAP_I_TO_G_SIZE = #0CB3 
global constant GL_PIXEL_MAP_I_TO_B_SIZE = #0CB4 
global constant GL_PIXEL_MAP_I_TO_A_SIZE = #0CB5 
global constant GL_PIXEL_MAP_R_TO_R_SIZE = #0CB6 
global constant GL_PIXEL_MAP_G_TO_G_SIZE = #0CB7 
global constant GL_PIXEL_MAP_B_TO_B_SIZE = #0CB8 
global constant GL_PIXEL_MAP_A_TO_A_SIZE = #0CB9 
global constant GL_UNPACK_SWAP_BYTES = #0CF0 
global constant GL_UNPACK_LSB_FIRST = #0CF1 
global constant GL_UNPACK_ROW_LENGTH = #0CF2 
global constant GL_UNPACK_SKIP_ROWS = #0CF3 
global constant GL_UNPACK_SKIP_PIXELS = #0CF4 
global constant GL_UNPACK_ALIGNMENT = #0CF5 
global constant GL_PACK_SWAP_BYTES = #0D00 
global constant GL_PACK_LSB_FIRST = #0D01 
global constant GL_PACK_ROW_LENGTH = #0D02 
global constant GL_PACK_SKIP_ROWS = #0D03 
global constant GL_PACK_SKIP_PIXELS = #0D04 
global constant GL_PACK_ALIGNMENT = #0D05 
global constant GL_MAP_COLOR = #0D10 
global constant GL_MAP_STENCIL = #0D11 
global constant GL_INDEX_SHIFT = #0D12 
global constant GL_INDEX_OFFSET = #0D13 
global constant GL_RED_SCALE = #0D14 
global constant GL_RED_BIAS = #0D15 
global constant GL_ZOOM_X = #0D16 
global constant GL_ZOOM_Y = #0D17 
global constant GL_GREEN_SCALE = #0D18 
global constant GL_GREEN_BIAS = #0D19 
global constant GL_BLUE_SCALE = #0D1A 
global constant GL_BLUE_BIAS = #0D1B 
global constant GL_ALPHA_SCALE = #0D1C 
global constant GL_ALPHA_BIAS = #0D1D 
global constant GL_DEPTH_SCALE = #0D1E 
global constant GL_DEPTH_BIAS = #0D1F 
global constant GL_MAX_EVAL_ORDER = #0D30 
global constant GL_MAX_LIGHTS = #0D31 
global constant GL_MAX_CLIP_PLANES = #0D32 
global constant GL_MAX_TEXTURE_SIZE = #0D33 
global constant GL_MAX_PIXEL_MAP_TABLE = #0D34 
global constant GL_MAX_ATTRIB_STACK_DEPTH = #0D35 
global constant GL_MAX_MODELVIEW_STACK_DEPTH = #0D36 
global constant GL_MAX_NAME_STACK_DEPTH = #0D37 
global constant GL_MAX_PROJECTION_STACK_DEPTH = #0D38 
global constant GL_MAX_TEXTURE_STACK_DEPTH = #0D39 
global constant GL_MAX_VIEWPORT_DIMS = #0D3A 
global constant GL_MAX_CLIENT_ATTRIB_STACK_DEPTH = #0D3B 
global constant GL_SUBPIXEL_BITS = #0D50 
global constant GL_INDEX_BITS = #0D51 
global constant GL_RED_BITS = #0D52 
global constant GL_GREEN_BITS = #0D53 
global constant GL_BLUE_BITS = #0D54 
global constant GL_ALPHA_BITS = #0D55 
global constant GL_DEPTH_BITS = #0D56 
global constant GL_STENCIL_BITS = #0D57 
global constant GL_ACCUM_RED_BITS = #0D58 
global constant GL_ACCUM_GREEN_BITS = #0D59 
global constant GL_ACCUM_BLUE_BITS = #0D5A 
global constant GL_ACCUM_ALPHA_BITS = #0D5B 
global constant GL_NAME_STACK_DEPTH = #0D70 
global constant GL_AUTO_NORMAL = #0D80 
global constant GL_MAP1_COLOR_4 = #0D90 
global constant GL_MAP1_INDEX = #0D91 
global constant GL_MAP1_NORMAL = #0D92 
global constant GL_MAP1_TEXTURE_COORD_1 = #0D93 
global constant GL_MAP1_TEXTURE_COORD_2 = #0D94 
global constant GL_MAP1_TEXTURE_COORD_3 = #0D95 
global constant GL_MAP1_TEXTURE_COORD_4 = #0D96 
global constant GL_MAP1_VERTEX_3 = #0D97 
global constant GL_MAP1_VERTEX_4 = #0D98 
global constant GL_MAP2_COLOR_4 = #0DB0 
global constant GL_MAP2_INDEX = #0DB1 
global constant GL_MAP2_NORMAL = #0DB2 
global constant GL_MAP2_TEXTURE_COORD_1 = #0DB3 
global constant GL_MAP2_TEXTURE_COORD_2 = #0DB4 
global constant GL_MAP2_TEXTURE_COORD_3 = #0DB5 
global constant GL_MAP2_TEXTURE_COORD_4 = #0DB6 
global constant GL_MAP2_VERTEX_3 = #0DB7 
global constant GL_MAP2_VERTEX_4 = #0DB8 
global constant GL_MAP1_GRID_DOMAIN = #0DD0 
global constant GL_MAP1_GRID_SEGMENTS = #0DD1 
global constant GL_MAP2_GRID_DOMAIN = #0DD2 
global constant GL_MAP2_GRID_SEGMENTS = #0DD3 
global constant GL_TEXTURE_1D = #0DE0 
global constant GL_TEXTURE_2D = #0DE1 
global constant GL_FEEDBACK_BUFFER_POINTER = #0DF0 
global constant GL_FEEDBACK_BUFFER_SIZE = #0DF1 
global constant GL_FEEDBACK_BUFFER_TYPE = #0DF2 
global constant GL_SELECTION_BUFFER_POINTER = #0DF3 
global constant GL_SELECTION_BUFFER_SIZE = #0DF4 
global constant GL_POLYGON_OFFSET_UNITS = #2A00 
global constant GL_POLYGON_OFFSET_POINT = #2A01 
global constant GL_POLYGON_OFFSET_LINE = #2A02 
global constant GL_POLYGON_OFFSET_FILL = #8037 
global constant GL_POLYGON_OFFSET_FACTOR = #8038 
global constant GL_TEXTURE_BINDING_1D = #8068 
global constant GL_TEXTURE_BINDING_2D = #8069 
global constant GL_VERTEX_ARRAY = #8074 
global constant GL_NORMAL_ARRAY = #8075 
global constant GL_COLOR_ARRAY = #8076 
global constant GL_INDEX_ARRAY = #8077 
global constant GL_TEXTURE_COORD_ARRAY = #8078 
global constant GL_EDGE_FLAG_ARRAY = #8079 
global constant GL_VERTEX_ARRAY_SIZE = #807A 
global constant GL_VERTEX_ARRAY_TYPE = #807B 
global constant GL_VERTEX_ARRAY_STRIDE = #807C 
global constant GL_NORMAL_ARRAY_TYPE = #807E 
global constant GL_NORMAL_ARRAY_STRIDE = #807F 
global constant GL_COLOR_ARRAY_SIZE = #8081 
global constant GL_COLOR_ARRAY_TYPE = #8082 
global constant GL_COLOR_ARRAY_STRIDE = #8083 
global constant GL_INDEX_ARRAY_TYPE = #8085 
global constant GL_INDEX_ARRAY_STRIDE = #8086 
global constant GL_TEXTURE_COORD_ARRAY_SIZE = #8088 
global constant GL_TEXTURE_COORD_ARRAY_TYPE = #8089 
global constant GL_TEXTURE_COORD_ARRAY_STRIDE = #808A 
global constant GL_EDGE_FLAG_ARRAY_STRIDE = #808C 
--      GL_VERTEX_ARRAY_COUNT_EXT 
--      GL_NORMAL_ARRAY_COUNT_EXT 
--      GL_COLOR_ARRAY_COUNT_EXT 
--      GL_INDEX_ARRAY_COUNT_EXT 
--      GL_TEXTURE_COORD_ARRAY_COUNT_EXT 
--      GL_EDGE_FLAG_ARRAY_COUNT_EXT 
--      GL_ARRAY_ELEMENT_LOCK_COUNT_SGI 
--      GL_ARRAY_ELEMENT_LOCK_FIRST_SGI 
--      GL_INDEX_TEST_SGI 
--      GL_INDEX_TEST_FUNC_SGI 
--      GL_INDEX_TEST_REF_SGI 
--      GL_INDEX_MATERIAL_SGI 
--      GL_INDEX_MATERIAL_FACE_SGI 
--      GL_INDEX_MATERIAL_PARAMETER_SGI 

-- GetTextureParameter 
--      GL_TEXTURE_MAG_FILTER 
--      GL_TEXTURE_MIN_FILTER 
--      GL_TEXTURE_WRAP_S 
--      GL_TEXTURE_WRAP_T 
global constant GL_TEXTURE_WIDTH = #1000 
global constant GL_TEXTURE_HEIGHT = #1001 
global constant GL_TEXTURE_INTERNAL_FORMAT = #1003 
global constant GL_TEXTURE_COMPONENTS = GL_TEXTURE_INTERNAL_FORMAT 
global constant GL_TEXTURE_BORDER_COLOR = #1004 
global constant GL_TEXTURE_BORDER = #1005 
global constant GL_TEXTURE_RED_SIZE = #805C 
global constant GL_TEXTURE_GREEN_SIZE = #805D 
global constant GL_TEXTURE_BLUE_SIZE = #805E 
global constant GL_TEXTURE_ALPHA_SIZE = #805F 
global constant GL_TEXTURE_LUMINANCE_SIZE = #8060 
global constant GL_TEXTURE_INTENSITY_SIZE = #8061 
global constant GL_TEXTURE_PRIORITY = #8066 
global constant GL_TEXTURE_RESIDENT = #8067 

-- HintMode 
global constant GL_DONT_CARE = #1100 
global constant GL_FASTEST = #1101 
global constant GL_NICEST = #1102 

-- HintTarget 
--      GL_PERSPECTIVE_CORRECTION_HINT 
--      GL_POINT_SMOOTH_HINT 
--      GL_LINE_SMOOTH_HINT 
--      GL_POLYGON_SMOOTH_HINT 
--      GL_FOG_HINT 

-- IndexMaterialParameterSGI 
--      GL_INDEX_OFFSET 

-- IndexPointerType 
--      GL_SHORT 
--      GL_INT 
--      GL_FLOAT 
--      GL_DOUBLE 

-- IndexFunctionSGI 
--      GL_NEVER 
--      GL_LESS 
--      GL_EQUAL 
--      GL_LEQUAL 
--      GL_GREATER 
--      GL_NOTEQUAL 
--      GL_GEQUAL 
--      GL_ALWAYS 

-- LightModelParameter 
--      GL_LIGHT_MODEL_AMBIENT 
--      GL_LIGHT_MODEL_LOCAL_VIEWER 
--      GL_LIGHT_MODEL_TWO_SIDE 

-- LightParameter 
global constant GL_AMBIENT = #1200 
global constant GL_DIFFUSE = #1201 
global constant GL_SPECULAR = #1202 
global constant GL_POSITION = #1203 
global constant GL_SPOT_DIRECTION = #1204 
global constant GL_SPOT_EXPONENT = #1205 
global constant GL_SPOT_CUTOFF = #1206 
global constant GL_CONSTANT_ATTENUATION = #1207 
global constant GL_LINEAR_ATTENUATION = #1208 
global constant GL_QUADRATIC_ATTENUATION = #1209 

-- ListMode 
global constant GL_COMPILE = #1300 
global constant GL_COMPILE_AND_EXECUTE = #1301 

-- DataType 
global constant GL_BYTE = #1400 
global constant GL_UNSIGNED_BYTE = #1401 
global constant GL_SHORT = #1402 
global constant GL_UNSIGNED_SHORT = #1403 
global constant GL_INT = #1404 
global constant GL_UNSIGNED_INT = #1405 
global constant GL_FLOAT = #1406 
global constant GL_2_BYTES = #1407 
global constant GL_3_BYTES = #1408 
global constant GL_4_BYTES = #1409 
global constant GL_DOUBLE = #140A 
global constant GL_DOUBLE_EXT = #140A 

-- ListNameType 
--      GL_BYTE 
--      GL_UNSIGNED_BYTE 
--      GL_SHORT 
--      GL_UNSIGNED_SHORT 
--      GL_INT 
--      GL_UNSIGNED_INT 
--      GL_FLOAT 
--      GL_2_BYTES 
--      GL_3_BYTES 
--      GL_4_BYTES 

-- LogicOp 
global constant GL_CLEAR = #1500 
global constant GL_AND = #1501 
global constant GL_AND_REVERSE = #1502 
global constant GL_COPY = #1503 
global constant GL_AND_INVERTED = #1504 
global constant GL_NOOP = #1505 
global constant GL_XOR = #1506 
global constant GL_OR = #1507 
global constant GL_NOR = #1508 
global constant GL_EQUIV = #1509 
global constant GL_INVERT = #150A 
global constant GL_OR_REVERSE = #150B 
global constant GL_COPY_INVERTED = #150C 
global constant GL_OR_INVERTED = #150D 
global constant GL_NAND = #150E 
global constant GL_SET = #150F 

-- MapTarget 
--      GL_MAP1_COLOR_4 
--      GL_MAP1_INDEX 
--      GL_MAP1_NORMAL 
--      GL_MAP1_TEXTURE_COORD_1 
--      GL_MAP1_TEXTURE_COORD_2 
--      GL_MAP1_TEXTURE_COORD_3 
--      GL_MAP1_TEXTURE_COORD_4 
--      GL_MAP1_VERTEX_3 
--      GL_MAP1_VERTEX_4 
--      GL_MAP2_COLOR_4 
--      GL_MAP2_INDEX 
--      GL_MAP2_NORMAL 
--      GL_MAP2_TEXTURE_COORD_1 
--      GL_MAP2_TEXTURE_COORD_2 
--      GL_MAP2_TEXTURE_COORD_3 
--      GL_MAP2_TEXTURE_COORD_4 
--      GL_MAP2_VERTEX_3 
--      GL_MAP2_VERTEX_4 

-- MaterialFace 
--      GL_FRONT 
--      GL_BACK 
--      GL_FRONT_AND_BACK 

-- MaterialParameter 
global constant GL_EMISSION = #1600 
global constant GL_SHININESS = #1601 
global constant GL_AMBIENT_AND_DIFFUSE = #1602 
global constant GL_COLOR_INDEXES = #1603 
--      GL_AMBIENT 
--      GL_DIFFUSE 
--      GL_SPECULAR 

-- MatrixMode 
global constant GL_MODELVIEW = #1700 
global constant GL_PROJECTION = #1701 
global constant GL_TEXTURE = #1702 

-- MeshMode1 
--      GL_POINT 
--      GL_LINE 

-- MeshMode2 
--      GL_POINT 
--      GL_LINE 
--      GL_FILL 

-- NormalPointerType 
--      GL_BYTE 
--      GL_SHORT 
--      GL_INT 
--      GL_FLOAT 
--      GL_DOUBLE 

-- PixelCopyType 
global constant GL_COLOR = #1800 
global constant GL_DEPTH = #1801 
global constant GL_STENCIL = #1802 

-- PixelFormat 
global constant GL_COLOR_INDEX = #1900 
global constant GL_STENCIL_INDEX = #1901 
global constant GL_DEPTH_COMPONENT = #1902 
global constant GL_RED = #1903 
global constant GL_GREEN = #1904 
global constant GL_BLUE = #1905 
global constant GL_ALPHA = #1906 
global constant GL_RGB = #1907 
global constant GL_RGBA = #1908 
global constant GL_LUMINANCE = #1909 
global constant GL_LUMINANCE_ALPHA = #190A 
--      GL_ABGR_EXT 
--      GL_BGR_EXT 
--      GL_BGRA_EXT 

-- PixelMap 
--      GL_PIXEL_MAP_I_TO_I 
--      GL_PIXEL_MAP_S_TO_S 
--      GL_PIXEL_MAP_I_TO_R 
--      GL_PIXEL_MAP_I_TO_G 
--      GL_PIXEL_MAP_I_TO_B 
--      GL_PIXEL_MAP_I_TO_A 
--      GL_PIXEL_MAP_R_TO_R 
--      GL_PIXEL_MAP_G_TO_G 
--      GL_PIXEL_MAP_B_TO_B 
--      GL_PIXEL_MAP_A_TO_A 

-- PixelStoreParameter 
--      GL_UNPACK_SWAP_BYTES 
--      GL_UNPACK_LSB_FIRST 
--      GL_UNPACK_ROW_LENGTH 
--      GL_UNPACK_SKIP_ROWS 
--      GL_UNPACK_SKIP_PIXELS 
--      GL_UNPACK_ALIGNMENT 
--      GL_PACK_SWAP_BYTES 
--      GL_PACK_LSB_FIRST 
--      GL_PACK_ROW_LENGTH 
--      GL_PACK_SKIP_ROWS 
--      GL_PACK_SKIP_PIXELS 
--      GL_PACK_ALIGNMENT 

-- PixelTransferParameter 
--      GL_MAP_COLOR 
--      GL_MAP_STENCIL 
--      GL_INDEX_SHIFT 
--      GL_INDEX_OFFSET 
--      GL_RED_SCALE 
--      GL_RED_BIAS 
--      GL_GREEN_SCALE 
--      GL_GREEN_BIAS 
--      GL_BLUE_SCALE 
--      GL_BLUE_BIAS 
--      GL_ALPHA_SCALE 
--      GL_ALPHA_BIAS 
--      GL_DEPTH_SCALE 
--      GL_DEPTH_BIAS 

-- PixelType 
global constant GL_BITMAP = #1A00 
--      GL_BYTE 
--      GL_UNSIGNED_BYTE 
--      GL_SHORT 
--      GL_UNSIGNED_SHORT 
--      GL_INT 
--      GL_UNSIGNED_INT 
--      GL_FLOAT 
--      GL_UNSIGNED_BYTE_3_3_2_EXT 
--      GL_UNSIGNED_SHORT_4_4_4_4_EXT 
--      GL_UNSIGNED_SHORT_5_5_5_1_EXT 
--      GL_UNSIGNED_INT_8_8_8_8_EXT 
--      GL_UNSIGNED_INT_10_10_10_2_EXT 

-- PolygonMode 
global constant GL_POINT = #1B00 
global constant GL_LINE = #1B01 
global constant GL_FILL = #1B02 

-- ReadBufferMode 
--      GL_FRONT_LEFT 
--      GL_FRONT_RIGHT 
--      GL_BACK_LEFT 
--      GL_BACK_RIGHT 
--      GL_FRONT 
--      GL_BACK 
--      GL_LEFT 
--      GL_RIGHT 
--      GL_AUX0 
--      GL_AUX1 
--      GL_AUX2 
--      GL_AUX3 

-- RenderingMode 
global constant GL_RENDER = #1C00 
global constant GL_FEEDBACK = #1C01 
global constant GL_SELECT = #1C02 

-- ShadingModel 
global constant GL_FLAT = #1D00 
global constant GL_SMOOTH = #1D01 

-- StencilFunction 
--      GL_NEVER 
--      GL_LESS 
--      GL_EQUAL 
--      GL_LEQUAL 
--      GL_GREATER 
--      GL_NOTEQUAL 
--      GL_GEQUAL 
--      GL_ALWAYS 

-- StencilOp 
--      GL_ZERO 
global constant GL_KEEP = #1E00 
global constant GL_REPLACE = #1E01 
global constant GL_INCR = #1E02 
global constant GL_DECR = #1E03 
--      GL_INVERT 

-- StringName 
global constant GL_VENDOR = #1F00 
global constant GL_RENDERER = #1F01 
global constant GL_VERSION = #1F02 
global constant GL_EXTENSIONS = #1F03 

-- TexCoordPointerType 
--      GL_SHORT 
--      GL_INT 
--      GL_FLOAT 
--      GL_DOUBLE 

-- TextureCoordName 
global constant GL_S = #2000 
global constant GL_T = #2001 
global constant GL_R = #2002 
global constant GL_Q = #2003 

-- TextureEnvMode 
global constant GL_MODULATE = #2100 
global constant GL_DECAL = #2101 
--      GL_BLEND 
--      GL_REPLACE 
--      GL_ADD 

-- TextureEnvParameter 
global constant GL_TEXTURE_ENV_MODE = #2200 
global constant GL_TEXTURE_ENV_COLOR = #2201 

-- TextureEnvTarget 
global constant GL_TEXTURE_ENV = #2300 

-- TextureGenMode 
global constant GL_EYE_LINEAR = #2400 
global constant GL_OBJECT_LINEAR = #2401 
global constant GL_SPHERE_MAP = #2402 

-- TextureGenParameter 
global constant GL_TEXTURE_GEN_MODE = #2500 
global constant GL_OBJECT_PLANE = #2501 
global constant GL_EYE_PLANE = #2502 

-- TextureMagFilter 
global constant GL_NEAREST = #2600 
global constant GL_LINEAR = #2601 

-- TextureMinFilter 
--      GL_NEAREST 
--      GL_LINEAR 
global constant GL_NEAREST_MIPMAP_NEAREST = #2700 
global constant GL_LINEAR_MIPMAP_NEAREST = #2701 
global constant GL_NEAREST_MIPMAP_LINEAR = #2702 
global constant GL_LINEAR_MIPMAP_LINEAR = #2703 

-- TextureParameterName 
global constant GL_TEXTURE_MAG_FILTER = #2800 
global constant GL_TEXTURE_MIN_FILTER = #2801 
global constant GL_TEXTURE_WRAP_S = #2802 
global constant GL_TEXTURE_WRAP_T = #2803 
--      GL_TEXTURE_BORDER_COLOR 
--      GL_TEXTURE_PRIORITY 

-- TextureTarget 
--      GL_TEXTURE_1D 
--      GL_TEXTURE_2D 
global constant GL_PROXY_TEXTURE_1D = #8063 
global constant GL_PROXY_TEXTURE_2D = #8064 

-- TextureWrapMode 
global constant GL_CLAMP = #2900 
global constant GL_REPEAT = #2901 

-- PixelInternalFormat 
global constant GL_R3_G3_B2 = #2A10 
global constant GL_ALPHA4 = #803B 
global constant GL_ALPHA8 = #803C 
global constant GL_ALPHA12 = #803D 
global constant GL_ALPHA16 = #803E 
global constant GL_LUMINANCE4 = #803F 
global constant GL_LUMINANCE8 = #8040 
global constant GL_LUMINANCE12 = #8041 
global constant GL_LUMINANCE16 = #8042 
global constant GL_LUMINANCE4_ALPHA4 = #8043 
global constant GL_LUMINANCE6_ALPHA2 = #8044 
global constant GL_LUMINANCE8_ALPHA8 = #8045 
global constant GL_LUMINANCE12_ALPHA4 = #8046 
global constant GL_LUMINANCE12_ALPHA12 = #8047 
global constant GL_LUMINANCE16_ALPHA16 = #8048 
global constant GL_INTENSITY = #8049 
global constant GL_INTENSITY4 = #804A 
global constant GL_INTENSITY8 = #804B 
global constant GL_INTENSITY12 = #804C 
global constant GL_INTENSITY16 = #804D 
global constant GL_RGB4 = #804F 
global constant GL_RGB5 = #8050 
global constant GL_RGB8 = #8051 
global constant GL_RGB10 = #8052 
global constant GL_RGB12 = #8053 
global constant GL_RGB16 = #8054 
global constant GL_RGBA2 = #8055 
global constant GL_RGBA4 = #8056 
global constant GL_RGB5_A1 = #8057 
global constant GL_RGBA8 = #8058 
global constant GL_RGB10_A2 = #8059 
global constant GL_RGBA12 = #805A 
global constant GL_RGBA16 = #805B 
--      GL_COLOR_INDEX1_EXT 
--      GL_COLOR_INDEX2_EXT 
--      GL_COLOR_INDEX4_EXT 
--      GL_COLOR_INDEX8_EXT 
--      GL_COLOR_INDEX12_EXT 
--      GL_COLOR_INDEX16_EXT 

-- InterleavedArrayFormat 
global constant GL_V2F = #2A20 
global constant GL_V3F = #2A21 
global constant GL_C4UB_V2F = #2A22 
global constant GL_C4UB_V3F = #2A23 
global constant GL_C3F_V3F = #2A24 
global constant GL_N3F_V3F = #2A25 
global constant GL_C4F_N3F_V3F = #2A26 
global constant GL_T2F_V3F = #2A27 
global constant GL_T4F_V4F = #2A28 
global constant GL_T2F_C4UB_V3F = #2A29 
global constant GL_T2F_C3F_V3F = #2A2A 
global constant GL_T2F_N3F_V3F = #2A2B 
global constant GL_T2F_C4F_N3F_V3F = #2A2C 
global constant GL_T4F_C4F_N3F_V4F = #2A2D 
--      GL_IUI_V2F_SGI 
--      GL_IUI_V3F_SGI 
--      GL_IUI_N3F_V2F_SGI 
--      GL_IUI_N3F_V3F_SGI 
--      GL_T2F_IUI_V2F_SGI 
--      GL_T2F_IUI_V3F_SGI 
--      GL_T2F_IUI_N3F_V2F_SGI 
--      GL_T2F_IUI_N3F_V3F_SGI 

-- VertexPointerType 
--      GL_SHORT 
--      GL_INT 
--      GL_FLOAT 
--      GL_DOUBLE 

-- ClipPlaneName 
global constant GL_CLIP_PLANE0 = #3000 
global constant GL_CLIP_PLANE1 = #3001 
global constant GL_CLIP_PLANE2 = #3002 
global constant GL_CLIP_PLANE3 = #3003 
global constant GL_CLIP_PLANE4 = #3004 
global constant GL_CLIP_PLANE5 = #3005 

-- LightName 
global constant GL_LIGHT0 = #4000 
global constant GL_LIGHT1 = #4001 
global constant GL_LIGHT2 = #4002 
global constant GL_LIGHT3 = #4003 
global constant GL_LIGHT4 = #4004 
global constant GL_LIGHT5 = #4005 
global constant GL_LIGHT6 = #4006 
global constant GL_LIGHT7 = #4007 

-- EXT_abgr 
global constant GL_ABGR_EXT = #8000 

-- EXT_packed_pixels 
global constant GL_UNSIGNED_BYTE_3_3_2_EXT = #8032 
global constant GL_UNSIGNED_SHORT_4_4_4_4_EXT = #8033 
global constant GL_UNSIGNED_SHORT_5_5_5_1_EXT = #8034 
global constant GL_UNSIGNED_INT_8_8_8_8_EXT = #8035 
global constant GL_UNSIGNED_INT_10_10_10_2_EXT = #8036 

-- EXT_vertex_array 
global constant GL_VERTEX_ARRAY_EXT = #8074 
global constant GL_NORMAL_ARRAY_EXT = #8075 
global constant GL_COLOR_ARRAY_EXT = #8076 
global constant GL_INDEX_ARRAY_EXT = #8077 
global constant GL_TEXTURE_COORD_ARRAY_EXT = #8078 
global constant GL_EDGE_FLAG_ARRAY_EXT = #8079 
global constant GL_VERTEX_ARRAY_SIZE_EXT = #807A 
global constant GL_VERTEX_ARRAY_TYPE_EXT = #807B 
global constant GL_VERTEX_ARRAY_STRIDE_EXT = #807C 
global constant GL_VERTEX_ARRAY_COUNT_EXT = #807D 
global constant GL_NORMAL_ARRAY_TYPE_EXT = #807E 
global constant GL_NORMAL_ARRAY_STRIDE_EXT = #807F 
global constant GL_NORMAL_ARRAY_COUNT_EXT = #8080 
global constant GL_COLOR_ARRAY_SIZE_EXT = #8081 
global constant GL_COLOR_ARRAY_TYPE_EXT = #8082 
global constant GL_COLOR_ARRAY_STRIDE_EXT = #8083 
global constant GL_COLOR_ARRAY_COUNT_EXT = #8084 
global constant GL_INDEX_ARRAY_TYPE_EXT = #8085 
global constant GL_INDEX_ARRAY_STRIDE_EXT = #8086 
global constant GL_INDEX_ARRAY_COUNT_EXT = #8087 
global constant GL_TEXTURE_COORD_ARRAY_SIZE_EXT = #8088 
global constant GL_TEXTURE_COORD_ARRAY_TYPE_EXT = #8089 
global constant GL_TEXTURE_COORD_ARRAY_STRIDE_EXT = #808A 
global constant GL_TEXTURE_COORD_ARRAY_COUNT_EXT = #808B 
global constant GL_EDGE_FLAG_ARRAY_STRIDE_EXT = #808C 
global constant GL_EDGE_FLAG_ARRAY_COUNT_EXT = #808D 
global constant GL_VERTEX_ARRAY_POINTER_EXT = #808E 
global constant GL_NORMAL_ARRAY_POINTER_EXT = #808F 
global constant GL_COLOR_ARRAY_POINTER_EXT = #8090 
global constant GL_INDEX_ARRAY_POINTER_EXT = #8091 
global constant GL_TEXTURE_COORD_ARRAY_POINTER_EXT = #8092 
global constant GL_EDGE_FLAG_ARRAY_POINTER_EXT = #8093 

-- EXT_color_table 
global constant GL_TABLE_TOO_LARGE_EXT = #8031 
global constant GL_COLOR_TABLE_FORMAT_EXT = #80D8 
global constant GL_COLOR_TABLE_WIDTH_EXT = #80D9 
global constant GL_COLOR_TABLE_RED_SIZE_EXT = #80DA 
global constant GL_COLOR_TABLE_GREEN_SIZE_EXT = #80DB 
global constant GL_COLOR_TABLE_BLUE_SIZE_EXT = #80DC 
global constant GL_COLOR_TABLE_ALPHA_SIZE_EXT = #80DD 
global constant GL_COLOR_TABLE_LUMINANCE_SIZE_EXT = #80DE 
global constant GL_COLOR_TABLE_INTENSITY_SIZE_EXT = #80DF 

-- EXT_bgra 
global constant GL_BGR_EXT = #80E0 
global constant GL_BGRA_EXT = #80E1 

-- EXT_paletted_texture 
global constant GL_COLOR_INDEX1_EXT = #80E2 
global constant GL_COLOR_INDEX2_EXT = #80E3 
global constant GL_COLOR_INDEX4_EXT = #80E4 
global constant GL_COLOR_INDEX8_EXT = #80E5 
global constant GL_COLOR_INDEX12_EXT = #80E6 
global constant GL_COLOR_INDEX16_EXT = #80E7 

-- SGI_compiled_vertex_array 
global constant GL_ARRAY_ELEMENT_LOCK_FIRST_SGI = #81A8 
global constant GL_ARRAY_ELEMENT_LOCK_COUNT_SGI = #81A9 

-- SGI_cull_vertex 
global constant GL_CULL_VERTEX_SGI = #81AA 
global constant GL_CULL_VERTEX_EYE_POSITION_SGI = #81AB 
global constant GL_CULL_VERTEX_OBJECT_POSITION_SGI = #81AC 

-- SGI_index_array_formats 
global constant GL_IUI_V2F_SGI = #81AD 
global constant GL_IUI_V3F_SGI = #81AE 
global constant GL_IUI_N3F_V2F_SGI = #81AF 
global constant GL_IUI_N3F_V3F_SGI = #81B0 
global constant GL_T2F_IUI_V2F_SGI = #81B1 
global constant GL_T2F_IUI_V3F_SGI = #81B2 
global constant GL_T2F_IUI_N3F_V2F_SGI = #81B3 
global constant GL_T2F_IUI_N3F_V3F_SGI = #81B4 

-- SGI_index_func 
global constant GL_INDEX_TEST_SGI = #81B5 
global constant GL_INDEX_TEST_FUNC_SGI = #81B6 
global constant GL_INDEX_TEST_REF_SGI = #81B7 

-- SGI_index_material 
global constant GL_INDEX_MATERIAL_SGI = #81B8 
global constant GL_INDEX_MATERIAL_PARAMETER_SGI = #81B9 
global constant GL_INDEX_MATERIAL_FACE_SGI = #81BA 

--***********************************************************



--*************** Link functions from OpenGl32.dll **********
atom opengl32

if platform()=LINUX then
	opengl32 = open_dll(GL_LIBPATH & "libGL.so")
else
	opengl32 = open_dll("opengl32.dll")
end if

if opengl32 = NULL then
 	if platform()=LINUX then
 		puts(1,"Error! Can\'t find " & GL_LIBPATH & "libGL.so")
  	else
  		puts(1,"Error! Can\'t find opengl32.dll")
  	end if
end if





global integer wglCopyContext,wglCreateContext,wglCreateLayerContext,
               wglDeleteContext,wglGetCurrentContext,wglGetCurrentDC,
               wglMakeCurrent,wglSwapBuffers,wglSwapLayerBuffers,
               wglUseFontOutlines,

               glAccum,glAlphaFunc,glAreTexturesResident,glArrayElement, 
               glBegin,glBindTexture,glBitmap,glBlendFunc, 
               glCallList,glCallLists,glClear,glClearAccum, 
               glClearColor,glClearDepth,glClearIndex,glClearStencil, 
               glClipPlane,glColor3b,glColor3bv,glColor3d, 
               glColor3dv,glColor3f,glColor3fv,glColor3i, 
               glColor3iv,glColor3s,glColor3sv,glColor3ub, 
               glColor3ubv,glColor3ui,glColor3uiv,glColor3us,glColor3usv, 
               glColor4b,glColor4bv,glColor4d,glColor4dv,
               glColor4f,glColor4fv,glColor4i,glColor4iv,
               glColor4s,glColor4sv,glColor4ub,glColor4ubv,
               glColor4ui,glColor4uiv,glColor4us,glColor4usv,
               glColorMask,glColorMaterial,glColorPointer,glCopyPixels, 
               glCopyTexImage1D,glCopyTexImage2D,glCopyTexSubImage1D,glCopyTexSubImage2D, 
               glCullFace,glDeleteLists,glDeleteTextures,glDepthFunc, 
               glDepthMask,glDepthRange,glDisable,glDisableClientState, 
               glDrawArrays,glDrawBuffer,glDrawElements,glDrawPixels, 
               glEdgeFlag,glEdgeFlagPointer,glEdgeFlagv,glEnable, 
               glEnableClientState,glEnd,glEndList,glEvalCoord1d, 
               glEvalCoord1dv,glEvalCoord1f,glEvalCoord1fv,glEvalCoord2d, 
               glEvalCoord2dv,glEvalCoord2f,glEvalCoord2fv,glEvalMesh1, 
               glEvalMesh2,glEvalPoint1,glEvalPoint2,
               glFeedbackBuffer,glFinish,glFlush,glFogf,
               glFogfv,glFogi,glFogiv,glFrontFace, 
               glFrustum,glGenLists,glGenTextures,glGetBooleanv, 
               glGetClipPlane,glGetDoublev,glGetError,glGetFloatv, 
               glGetIntegerv,glGetLightfv,glGetLightiv,glGetMapdv,
               glGetMapfv,glGetMapiv,glGetMaterialfv,glGetMaterialiv, 
               glGetPixelMapfv,glGetPixelMapuiv,glGetPixelMapusv,glGetPointerv, 
               glGetPolygonStipple,glGetString,glGetTexEnvfv,glGetTexEnviv,
               glGetTexGendv,glGetTexGenfv,glGetTexGeniv,glGetTexImage, 
               glGetTexLevelParameterfv,glGetTexLevelParameteriv,glGetTexParameterfv, 
               glGetTexParameteriv,glHint,glIndexMask,glIndexPointer, 
               glIndexd,glIndexdv,glIndexf,glIndexfv,glIndexi, 
               glIndexiv,glIndexs,glIndexsv,glIndexub,glIndexubv, 
               glInitNames,glInterleavedArrays,glIsEnabled,glIsList, 
               glIsTexture,glLightModelf,glLightModelfv,glLightModeli,
               glLightModeliv,glLightf,glLightfv,glLighti,glLightiv, 
               glLineStipple,glLineWidth,glListBase,glLoadIdentity,
               glLoadMatrixd,glLoadMatrixf,glLoadName,glLogicOp, 
               glMap1d,glMap1f,glMap2d,glMap2f,glMapGrid1d, 
               glMapGrid1f,glMapGrid2d,glMapGrid2f,glMaterialf,
               glMaterialfv,glMateriali,glMaterialiv,glMatrixMode, 
               glMultMatrixd,glMultMatrixf,glNewList,
               glPixelStorei,glRasterPos2i,

               glNormal3b,glNormal3bv,glNormal3d,glNormal3dv, 
               glNormal3f,glNormal3fv,glNormal3i,glNormal3iv, 
               glNormal3s,glNormal3sv,glNormalPointer,
 
               glOrtho, 
	       glPointSize,
               glPolygonMode,glPopMatrix,glPushMatrix,

               glReadBuffer,glReadPixels,
               glRectd,glRectdv,glRectf,glRectfv, 
               glRecti,glRectiv,glRects,glRectsv, 
               glRenderMode,glRotated,glRotatef,glScaled, 
               glScalef, 

               glScissor,glShadeModel,glSelectBuffer,
               glStencilFunc,glStencilMask,glStencilOp,
               glTranslated,glTranslatef, 

               glTexCoord1d,glTexCoord1dv,glTexCoord1f,glTexCoord1fv,
               glTexCoord1i,glTexCoord1iv,glTexCoord1s,glTexCoord1sv,
               glTexCoord2d,glTexCoord2dv,glTexCoord2f,glTexCoord2fv,
               glTexCoord2i,glTexCoord2iv,glTexCoord2s,glTexCoord2sv,
               glTexCoord3d,glTexCoord3dv,glTexCoord3f,glTexCoord3fv,
               glTexCoord3i,glTexCoord3iv,glTexCoord3s,glTexCoord3sv,
               glTexCoord4d,glTexCoord4dv,glTexCoord4f,glTexCoord4fv,
               glTexCoord4i,glTexCoord4iv,glTexCoord4s,glTexCoord4sv,
               glTexCoordPointer,glTexEnvf,glTexEnvfv,glTexEnvi,glTexEnviv,
               glTexGend,glTexGendv,glTexGenf,glTexGenfv,glTexGeni,
               glTexGeniv,glTexImage1D,glTexImage2D,glTexParameterf,
               glTexParameterfv,glTexParameteri,glTexParameteriv,
               glTexSubImage1D,glTexSubImage2D,

               glVertex2d,glVertex2dv,glVertex2f,glVertex2fv, 
               glVertex2i,glVertex2iv,glVertex2s,glVertex2sv, 
               glVertex3d,glVertex3dv,glVertex3f,glVertex3fv, 
               glVertex3i,glVertex3iv,glVertex3s,glVertex3sv, 
               glVertex4d,glVertex4dv,glVertex4f,glVertex4fv, 
               glVertex4i,glVertex4iv,glVertex4s,glVertex4sv,
               glViewport 



glAccum		= validate_proc(opengl32,"glAccum",{ GLenum,GLfloat })
glBegin		= validate_proc(opengl32,"glBegin",{ C_UINT })
glBindTexture	= validate_proc(opengl32,"glBindTexture",{ C_INT,C_UINT })
glBitmap	= validate_proc(opengl32,"glBitmap",{ C_INT,C_INT,C_FLOAT,C_FLOAT,C_FLOAT,C_FLOAT,C_POINTER })
glBlendFunc	= validate_proc(opengl32,"glBlendFunc",{C_INT,C_INT})
glCallList	= validate_proc(opengl32,"glCallList",{ C_UINT })
glCallLists	= validate_proc(opengl32,"glCallLists",{C_INT,C_INT,C_POINTER})
glClear		= validate_proc(opengl32,"glClear",{ C_UINT })
glClearAccum	= validate_proc(opengl32,"glClearAccum",{ GLfloat,GLfloat,GLfloat,GLfloat })
glClearColor	= validate_proc(opengl32,"glClearColor",{ GLclampf,GLclampf,GLclampf,GLclampf })
glClearDepth	= validate_proc(opengl32,"glClearDepth",{ C_DOUBLE })
glColor3b	= validate_proc(opengl32,"glColor3b",{ C_CHAR,C_CHAR,C_CHAR })
glColor3d	= validate_proc(opengl32,"glColor3d",{ C_DOUBLE,C_DOUBLE,C_DOUBLE })
glColor3f	= validate_proc(opengl32,"glColor3f",{ C_FLOAT,C_FLOAT,C_FLOAT })
glColor3i	= validate_proc(opengl32,"glColor3i",{ C_INT,C_INT,C_INT })
glColor4b	= validate_proc(opengl32,"glColor4b",{ C_CHAR,C_CHAR,C_CHAR,C_CHAR })
glColor4d	= validate_proc(opengl32,"glColor4d",{ C_DOUBLE,C_DOUBLE,C_DOUBLE,C_DOUBLE })
glColor4f	= validate_proc(opengl32,"glColor4f",{ C_FLOAT,C_FLOAT,C_FLOAT,C_FLOAT })
glColor4i	= validate_proc(opengl32,"glColor4i",{ C_INT,C_INT,C_INT,C_INT })
glCullFace	= validate_proc(opengl32,"glCullFace",{C_INT})
glDeleteLists	= validate_proc(opengl32,"glDeleteLists",{ C_INT,C_INT })
glDeleteTextures= validate_proc(opengl32,"glDeleteTextures",{C_INT,C_POINTER})
glDepthFunc	= validate_proc(opengl32,"glDepthFunc",{ C_INT })
glDisable	= validate_proc(opengl32,"glDisable",{ C_UINT })
glEnable	= validate_proc(opengl32,"glEnable",{ C_UINT })
glEnd		= validate_proc(opengl32,"glEnd",{  })
glEndList	= validate_proc(opengl32,"glEndList",{  })
glEvalMesh2	= validate_proc(opengl32,"glEvalMesh2",repeat(C_INT,5))
glFinish	= validate_proc(opengl32,"glFinish",{  })
glFlush		= validate_proc(opengl32,"glFlush",{  })
glFogf		= validate_proc(opengl32,"glFogf",{ GLenum,GLfloat })
glFogfv		= validate_proc(opengl32,"glFogfv",{ C_INT,C_POINTER })
glFogi		= validate_proc(opengl32,"glFogi",{ C_INT,C_INT })
glFogiv		= validate_proc(opengl32,"glFogiv",{ C_INT,C_POINTER })
glFrontFace	= validate_proc(opengl32,"glFrontFace",{ C_INT })
glFrustum	= validate_proc(opengl32,"glFrustum",repeat(C_DOUBLE,6))
glGenLists	= validate_func(opengl32,"glGenLists",{ C_INT },C_INT)
glGenTextures	= validate_proc(opengl32,"glGenTextures",{ C_INT,C_POINTER })
glHint		= validate_proc(opengl32,"glHint",{ C_INT,C_INT })
glIndexi	= validate_proc(opengl32,"glIndexi",{ C_INT })
glLightf	= validate_proc(opengl32,"glLightf",{ GLenum,GLenum,GLfloat })
glLightfv	= validate_proc(opengl32,"glLightfv",{ C_INT,C_INT,C_POINTER })
glLightModelf	= validate_proc(opengl32,"glLightModelf",{ C_INT,C_FLOAT })
glLightModelfv	= validate_proc(opengl32,"glLightModelfv",{ C_INT,C_POINTER })
glLineWidth	= validate_proc(opengl32,"glLineWidth",{C_FLOAT})
glListBase	= validate_proc(opengl32,"glListBase",{ C_UINT })
glLoadIdentity	= validate_proc(opengl32,"glLoadIdentity",{ }) 
glMap2f		= validate_proc(opengl32,"glMap2f",{ GLenum,GLfloat,GLfloat,GLint,GLint,GLfloat,GLfloat,GLint,GLint,C_POINTER })
glMapGrid2f	= validate_proc(opengl32,"glMapGrid2f",{ C_INT,C_FLOAT,C_FLOAT,C_INT,C_FLOAT,C_INT }) 
glMaterialf	= validate_proc(opengl32,"glMaterialf",{ C_UINT,C_UINT,C_FLOAT }) 
glMaterialfv	= validate_proc(opengl32,"glMaterialfv",{ C_INT,C_INT,C_POINTER })	
glMateriali	= validate_proc(opengl32,"glMateriali",{ C_UINT,C_UINT,C_INT }) 
glMatrixMode	= validate_proc(opengl32,"glMatrixMode",{ C_UINT })
glNewList	= validate_proc(opengl32,"glNewList",{ C_UINT,C_INT })
glNormal3b	= validate_proc(opengl32,"glNormal3b",{ C_CHAR,C_CHAR,C_CHAR })
glNormal3d	= validate_proc(opengl32,"glNormal3d",{ C_DOUBLE,C_DOUBLE,C_DOUBLE })
glNormal3f	= validate_proc(opengl32,"glNormal3f",{ C_FLOAT,C_FLOAT,C_FLOAT })
glNormal3i	= validate_proc(opengl32,"glNormal3i",{ C_INT,C_INT,C_INT })
glOrtho		= validate_proc(opengl32,"glOrtho",repeat(C_DOUBLE,6))
glPixelStorei	= validate_proc(opengl32,"glPixelStorei",{ C_INT,C_INT })
glPointSize	= validate_proc(opengl32,"glPointSize",{GLfloat})
glPolygonMode	= validate_proc(opengl32,"glPolygonMode",{ C_INT,C_INT })
glPopMatrix	= validate_proc(opengl32,"glPopMatrix",{ })
glPushMatrix	= validate_proc(opengl32,"glPushMatrix",{ })
glRasterPos2i	= validate_proc(opengl32,"glRasterPos2i",{ C_INT,C_INT })
glReadBuffer	= validate_proc(opengl32,"glReadBuffer",{ C_INT })
glReadPixels	= validate_proc(opengl32,"glReadPixels",repeat(C_INT,6) & C_POINTER)
glRectd		= validate_proc(opengl32,"glRectd",repeat(C_DOUBLE,4))
glRectdv	= validate_proc(opengl32,"glRectdv",{ C_POINTER })
glRectf		= validate_proc(opengl32,"glRectf",{ C_FLOAT,C_FLOAT,C_FLOAT,C_FLOAT })
glRectfv	= validate_proc(opengl32,"glRectfv",{ C_POINTER })
glRecti		= validate_proc(opengl32,"glRecti",repeat(C_INT,4))
glRectiv	= validate_proc(opengl32,"glRectiv",{ C_POINTER })
glRects		= validate_proc(opengl32,"glRects",repeat(C_SHORT,4))
glRectsv	= validate_proc(opengl32,"glRectsv",{ C_POINTER })
glRenderMode	= validate_func(opengl32,"glRenderMode",{ C_INT },C_INT)
glRotated	= validate_proc(opengl32,"glRotated",{ C_DOUBLE,C_DOUBLE,C_DOUBLE,C_DOUBLE })
glRotatef	= validate_proc(opengl32,"glRotatef",{ C_FLOAT,C_FLOAT,C_FLOAT,C_FLOAT })
glScalef	= validate_proc(opengl32,"glScalef",{ C_FLOAT,C_FLOAT,C_FLOAT })
glScissor	= validate_proc(opengl32,"glScissor",repeat(C_INT,4))
glSelectBuffer	= validate_proc(opengl32,"glSelectBuffer",{ C_INT,C_POINTER })
glShadeModel	= validate_proc(opengl32,"glShadeModel",{ C_UINT })
glStencilFunc	= validate_proc(opengl32,"glStencilFunc",{ C_INT,C_INT,C_UINT })
glStencilMask	= validate_proc(opengl32,"glStencilMask",{ C_UINT })
glStencilOp	= validate_proc(opengl32,"glStencilOp",{ C_INT,C_INT,C_INT })
glTexCoord1d	= validate_proc(opengl32,"glTexCoord1d",{ C_DOUBLE })
glTexCoord1dv	= validate_proc(opengl32,"glTexCoord1dv",{ C_POINTER })
glTexCoord1fv	= validate_proc(opengl32,"glTexCoord1fv",{ C_POINTER })
glTexCoord1i	= validate_proc(opengl32,"glTexCoord1i",{ C_INT })
glTexCoord1iv	= validate_proc(opengl32,"glTexCoord1iv",{ C_POINTER })
glTexCoord1s	= validate_proc(opengl32,"glTexCoord1s",{ C_SHORT })
glTexCoord1sv	= validate_proc(opengl32,"glTexCoord1sv",{ C_POINTER })
glTexCoord2d	= validate_proc(opengl32,"glTexCoord2d",{ C_DOUBLE,C_DOUBLE })
glTexCoord2dv	= validate_proc(opengl32,"glTexCoord2dv",{ C_POINTER })
glTexCoord2f	= validate_proc(opengl32,"glTexCoord2f",{ C_FLOAT,C_FLOAT })
glTexCoord2fv	= validate_proc(opengl32,"glTexCoord2fv",{ C_POINTER })
glTexCoord2i	= validate_proc(opengl32,"glTexCoord2i",{ C_INT,C_INT })
glTexCoord2iv	= validate_proc(opengl32,"glTexCoord2iv",{ C_POINTER })
glTexCoord2s	= validate_proc(opengl32,"glTexCoord2s",{ C_SHORT,C_SHORT })
glTexCoord2sv	= validate_proc(opengl32,"glTexCoord2sv",{ C_POINTER })
glTexCoord3d	= validate_proc(opengl32,"glTexCoord3d",{ C_DOUBLE,C_DOUBLE,C_DOUBLE })
glTexCoord3dv	= validate_proc(opengl32,"glTexCoord3dv",{ C_POINTER })
glTexCoord3f	= validate_proc(opengl32,"glTexCoord3f",{ C_FLOAT,C_FLOAT,C_FLOAT })
glTexCoord3fv	= validate_proc(opengl32,"glTexCoord3fv",{ C_POINTER })
glTexCoord3i	= validate_proc(opengl32,"glTexCoord3i",{ C_INT,C_INT,C_INT })
glTexCoord3iv	= validate_proc(opengl32,"glTexCoord3iv",{ C_POINTER })
glTexCoord3s	= validate_proc(opengl32,"glTexCoord3s",{ C_SHORT,C_SHORT,C_SHORT })
glTexCoord3sv	= validate_proc(opengl32,"glTexCoord3sv",{ C_POINTER })
glTexCoord4d	= validate_proc(opengl32,"glTexCoord4d",repeat(C_DOUBLE,4))
glTexCoord4dv	= validate_proc(opengl32,"glTexCoord4dv",{ C_POINTER })
glTexCoord4fv	= validate_proc(opengl32,"glTexCoord4fv",{ C_POINTER })
glTexCoord4i	= validate_proc(opengl32,"glTexCoord4i",repeat(C_INT,4))
glTexCoord4iv	= validate_proc(opengl32,"glTexCoord4iv",{ C_POINTER })
glTexCoord4s	= validate_proc(opengl32,"glTexCoord4s",repeat(C_SHORT,4))
glTexCoord4sv	= validate_proc(opengl32,"glTexCoord4sv",{ C_POINTER })
glTexEnvi	= validate_proc(opengl32,"glTexEnvi",{ C_INT,C_INT,C_INT })
glTexGeni	= validate_proc(opengl32,"glTexGeni",{C_INT,C_INT,C_INT})
glTexImage1D	= validate_proc(opengl32,"glTexImage1D",repeat(C_INT,7) & C_POINTER)
glTexImage2D	= validate_proc(opengl32,"glTexImage2D",repeat(C_INT,8) & C_POINTER)
glTexParameterfv= validate_proc(opengl32,"glTexParameterfv",{ C_INT,C_INT,C_POINTER })
glTexParameteri	= validate_proc(opengl32,"glTexParameteri",{ C_INT,C_INT,C_INT })
glTexParameteriv= validate_proc(opengl32,"glTexParameteriv",{ C_INT,C_INT,C_POINTER })
glTranslated	= validate_proc(opengl32,"glTranslated",{ C_DOUBLE,C_DOUBLE,C_DOUBLE })
glTranslatef	= validate_proc(opengl32,"glTranslatef",{ C_FLOAT,C_FLOAT,C_FLOAT })
glVertex2d	= validate_proc(opengl32,"glVertex2d",{ C_DOUBLE,C_DOUBLE })
glVertex2dv	= validate_proc(opengl32,"glVertex2dv",{ C_POINTER })
glVertex2f	= validate_proc(opengl32,"glVertex2f",{ C_FLOAT,C_FLOAT })
glVertex2fv	= validate_proc(opengl32,"glVertex2fv",{ C_POINTER })
glVertex2i	= validate_proc(opengl32,"glVertex2i",{ C_INT,C_INT })
glVertex2iv	= validate_proc(opengl32,"glVertex2iv",{ C_POINTER })
glVertex2s	= validate_proc(opengl32,"glVertex2s",{ C_SHORT,C_SHORT })
glVertex2sv	= validate_proc(opengl32,"glVertex2sv",{ C_POINTER })
glVertex3d	= validate_proc(opengl32,"glVertex3d",{ C_DOUBLE,C_DOUBLE,C_DOUBLE })
glVertex3dv	= validate_proc(opengl32,"glVertex3dv",{ C_POINTER })
glVertex3f	= validate_proc(opengl32,"glVertex3f",{ C_FLOAT,C_FLOAT,C_FLOAT })
glVertex3fv	= validate_proc(opengl32,"glVertex3fv",{ C_POINTER })
glVertex3i	= validate_proc(opengl32,"glVertex3i",{ C_INT,C_INT,C_INT })
glVertex3iv	= validate_proc(opengl32,"glVertex3iv",{ C_POINTER })
glVertex3s	= validate_proc(opengl32,"glVertex3s",{ C_SHORT,C_SHORT,C_SHORT })
glVertex3sv	= validate_proc(opengl32,"glVertex3sv",{ C_POINTER })
glVertex4d	= validate_proc(opengl32,"glVertex4d",{ C_DOUBLE,C_DOUBLE,C_DOUBLE,C_DOUBLE })
glVertex4dv	= validate_proc(opengl32,"glVertex4dv",{ C_POINTER })
glVertex4fv	= validate_proc(opengl32,"glVertex4fv",{ C_POINTER })
glVertex4i	= validate_proc(opengl32,"glVertex4i",{ C_INT,C_INT,C_INT,C_INT })
glVertex4iv	= validate_proc(opengl32,"glVertex4iv",{ C_POINTER })
glVertex4s	= validate_proc(opengl32,"glVertex4s",{ C_SHORT,C_SHORT,C_SHORT,C_SHORT })
glVertex4sv	= validate_proc(opengl32,"glVertex4sv",{ C_POINTER })
glViewport	= validate_proc(opengl32,"glViewport",{ C_INT,C_INT,C_INT,C_INT })
               


constant gl_vector_buffer = allocate(128)

procedure gl_pokef32(atom dest,sequence data)
	for i = 1 to length(data) do
		poke(dest,atom_to_float32(data[i]))
		dest += 4
	end for
end procedure


global procedure gl_accum(integer op,atom val)
	c_proc(glAccum,{op,val})
end procedure

global procedure gl_begin(integer what)
 	c_proc(glBegin,{ what })
end procedure

global procedure gl_bindTexture(integer target,atom tex)
	c_proc(glBindTexture,{target,tex})
end procedure

global procedure gl_bitmap(integer width,integer height,atom xorig,atom yorig,atom xmove,atom ymove,atom bitmap)
	c_proc(glBitmap,{width,height,xorig,yorig,xmove,ymove,bitmap})
end procedure

global procedure gl_blendFunc(integer sfactor, integer dfactor)
	c_proc(glBlendFunc,{sfactor,dfactor})
end procedure

global procedure gl_callList(integer list)
	c_proc(glCallList,{list})
end procedure

global procedure gl_callLists(integer n,integer typ,atom lists)
	c_proc(glCallLists,{n,typ,lists})
end procedure

global procedure gl_clear(integer mask)
	c_proc(glClear,{mask})
end procedure

global procedure gl_clearAccum(atom r,atom g,atom b,atom a)
 	c_proc(glClearAccum,{r,g,b,a})
end procedure

global procedure gl_clearColor(atom r,atom g,atom b,atom a)
 	c_proc(glClearColor,{r,g,b,a})
end procedure

global procedure gl_clearDepth(atom a)
	c_proc(glClearDepth,{a})
end procedure

global procedure gl_color3f(sequence col)
 	c_proc(glColor3f,col)
end procedure

global procedure gl_color4f(sequence col)
 	c_proc(glColor4f,col)
end procedure

global procedure gl_cullFace(integer mode)
	c_proc(glCullFace,{mode})
end procedure

global procedure gl_deleteLists(atom list,integer range)
	c_proc(glDeleteLists,{list,range})
end procedure

global procedure gl_deleteTextures(integer num,sequence textures)
	poke4(gl_vector_buffer,textures)
	c_proc(glDeleteTextures,{num,gl_vector_buffer})
end procedure

global procedure gl_depthFunc(integer f)
	c_proc(glDepthFunc,{f})
end procedure

global procedure gl_disable(integer what)
 	c_proc(glDisable,{ what })
end procedure

global procedure gl_enable(integer what)
 	c_proc(glEnable,{ what })
end procedure

global procedure gl_end()
 	c_proc(glEnd,{ })
end procedure

global procedure gl_endList()
	c_proc(glEndList,{})
end procedure

global procedure gl_finish()
 	c_proc(glFinish,{ })
end procedure

global procedure gl_flush()
 	c_proc(glFlush,{ })
end procedure

global procedure gl_fogf(integer pname,atom param)
	c_proc(glFogf,{pname,param})
end procedure

global procedure gl_fogfv(integer pname,sequence params)
	gl_pokef32(gl_vector_buffer,params)
	c_proc(glFogfv,{pname,gl_vector_buffer})
end procedure

global procedure gl_frustum(atom left,atom right,atom top,atom bottom,atom zNear,atom zFar)
	c_proc(glFrustum,{left,right,top,bottom,zNear,zFar})
end procedure

global function gl_genLists(integer range)
	return c_func(glGenLists,{range})
end function

global procedure gl_genTextures(integer n,atom textures)
	c_proc(glGenTextures,{n,textures})
end procedure

global procedure gl_hint(integer target,integer mode)
	c_proc(glHint,{target,mode})
end procedure

global procedure gl_indexi(integer idx)
	c_proc(glIndexi,{idx})
end procedure

global procedure gl_lightf(integer light,integer pname,atom val)
	c_proc(glLightf,{light,pname,val})
end procedure

global procedure gl_lightfv(integer light,integer pname,sequence vals)
	gl_pokef32(gl_vector_buffer,vals)
	c_proc(glLightfv,{light,pname,gl_vector_buffer})
end procedure

global procedure gl_lightModelf(integer i,atom val)
	c_proc(glLightModelf,{i,val})
end procedure

global procedure gl_lightModelfv(integer i,sequence vals)
	gl_pokef32(gl_vector_buffer,vals)
	c_proc(glLightModelfv,{i,gl_vector_buffer})
end procedure

global procedure gl_listBase(atom base)
	c_proc(glListBase,{base})
end procedure

global procedure gl_loadIdentity()
	c_proc(glLoadIdentity,{})
end procedure

global procedure gl_materialf(integer face,integer pname,atom val)
	c_proc(glMaterialf,{face,pname,val})
end procedure

global procedure gl_materialfv(integer face,integer pname,sequence vals)
	gl_pokef32(gl_vector_buffer,vals)
	c_proc(glMaterialfv,{face,pname,gl_vector_buffer})
end procedure

global procedure gl_matrixMode(integer mode)
	c_proc(glMatrixMode,{mode})
end procedure

global procedure gl_newList(integer list,integer mode)
	c_proc(glNewList,{list,mode})
end procedure

global procedure gl_normal3f(sequence normal)
	c_proc(glNormal3f,normal)
end procedure

global procedure gl_ortho(atom left,atom right,atom top,atom bottom,atom zNear,atom zFar)
	c_proc(glOrtho,{left,right,top,bottom,zNear,zFar})
end procedure

global procedure gl_pixelStorei(integer pname,integer param)
	c_proc(glPixelStorei,{pname,param})
end procedure

global procedure gl_pointSize(atom size)
	c_proc(glPointSize,{size})
end procedure

global procedure gl_polygonMode(integer face,integer mode)
	c_proc(glPolygonMode,{face,mode})
end procedure

global procedure gl_popMatrix()
 	c_proc(glPopMatrix,{ })
end procedure

global procedure gl_pushMatrix()
 	c_proc(glPushMatrix,{ })
end procedure

global procedure gl_rasterPos2i(sequence pos)
	c_proc(glRasterPos2i,pos)
end procedure

global procedure gl_rectf(sequence rect)
	c_proc(glRectf,rect)
end procedure

global procedure gl_rotatef(atom angle,sequence axes)
	c_proc(glRotatef,angle&axes)
end procedure

global procedure gl_scalef(sequence scale)
	c_proc(glScalef,scale)
end procedure

global procedure gl_shadeModel(integer model)
	c_proc(glShadeModel,{model})
end procedure

global procedure gl_texCoord2f(sequence c)
	c_proc(glTexCoord2f,c)
end procedure

global procedure gl_texImage2D(integer target, integer level, integer components, integer width, integer height,
				integer border, integer format, integer typ, atom pixels)
	c_proc(glTexImage2D,{target,level,components,width,height,border,format,typ,pixels})
end procedure

global procedure gl_texParameteri(integer target,integer pname,integer param)
	c_proc(glTexParameteri,{target,pname,param})
end procedure

global procedure gl_texEnvi(integer i,integer j,integer k)
	c_proc(glTexEnvi,{i,j,k})
end procedure

global procedure gl_texGeni(integer coord,integer pname,integer param)
	c_proc(glTexGeni,{coord,pname,param})
end procedure

global procedure gl_translatef(sequence t)
	c_proc(glTranslatef,t)
end procedure

global procedure gl_vertex2f(sequence vertex)
 	c_proc(glVertex2f,vertex)
end procedure

global procedure gl_vertex2i(sequence vertex)
 	c_proc(glVertex2i,vertex)
end procedure

global procedure gl_vertex3f(sequence vertex)
 	c_proc(glVertex3f,vertex)
end procedure

global procedure gl_vertex3i(sequence vertex)
 	c_proc(glVertex3i,vertex)
end procedure

global procedure gl_viewport(integer x,integer y,integer w,integer h)
 	c_proc(glViewport,{x,y,w,h})
end procedure
               

