global constant
	-- The different rendering modes
	NO_SHADING		= 0,
	FLAT_SHADING		= 1,
	SMOOTH_SHADING		= 2,
	CEL_SHADING		= 3,
	PENCIL_SKETCH_SHADING	= 4,
	INK_PEN_SKETCH_SHADING	= 5


-- Orientation of pieces
global constant 
	ORIENTATION_NORMAL	= 1,
	ORIENTATION_LEFT	= 2,
	ORIENTATION_RIGHT	= 3,
	ORIENTATION_DOWN	= 4


global constant
	CONSTANT_SPEED = 0.035,
	LEFT = -1,
	RIGHT = 1

-- Samples (sound effects)
global constant
	SAMPLE_MOVE = 1,
	SAMPLE_FLIP = 2,
	SAMPLE_HIT = 3,
	SAMPLE_DROP = 4,
	SAMPLE_SCORE = 5,
	SAMPLE_ABUNAI = 6,
	SAMPLE_BEAUTIFUL = 7,
	SAMPLE_BYEBYE = 8,
	SAMPLE_HUHU = 9,
	SAMPLE_LAKKI = 10,
	SAMPLE_LAKKIDESHOU = 11,
	SAMPLE_NICEDESUNE = 12,
	SAMPLE_OK = 13,
	SAMPLE_WOW = 14,
	SAMPLE_YOTTONE = 15
	
	
	
global constant pieces = {
{{
	"....",		-- 1
	"xxx.",
	".x..",
	"...."
},
{
	"....",		
	".x..",
	".xx.",
	".x.."
},
{
	"....",		
	".x..",
	"xxx.",
	"...."
},
{
	"....",		
	"..x.",
	".xx.",
	"..x."
}},
	
{{
	"....",		-- 2
	".xx.",
	"..xx",
	"...."
},
{
	"....",		
	"..x.",
	".xx.",
	".x.."
},
{
	"....",		
	".xx.",
	"..xx",
	"...."
},
{
	"....",		
	"..x.",
	".xx.",
	".x.."
}},
	
{{
	"....",		-- 3
	".xx.",
	"xx..",
	"...."
},
{
	"....",
	"x...",
	"xx..",
	".x.."
},
{
	"....",
	".xx.",
	"xx..",
	"...."
},
{
	"....",
	"x...",
	"xx..",
	".x.."
}},

{{
	"....",		-- 4
	"....",
	"xxxx",
	"...."
},
{
	".x..",
	".x..",
	".x..",
	".x.."
},
{
	"....",
	"....",
	"xxxx",
	"...."
},
{
	".x..",
	".x..",
	".x..",
	".x.."
}},
	
{{
	"....",		-- 5
	".xx.",
	".xx.",
	"...."
},
{
	"....",
	".xx.",
	".xx.",
	"...."
},
{
	"....",
	".xx.",
	".xx.",
	"...."
},
{
	"....",
	".xx.",
	".xx.",
	"...."
}},
	
{{
	"....",		-- 6
	"xxx.",
	"x...",
	"...."
},
{
	"....",
	"x...",
	"x...",
	"xx.."
},
{
	"....",
	"..x.",
	"xxx.",
	"...."
},
{
	".xx.",
	"..x.",
	"..x.",
	"...."
}},
	
{{
	"....",		-- 7
	"xxx.",
	"..x.",
	"...."
},
{
	"xx..",
	"x...",
	"x...",
	"...."
},
{
	"....",
	"x...",
	"xxx.",
	"...."
},
{
	"....",
	"..x.",
	"..x.",
	".xx."
}}
}-'.'



global constant vertexes = {
	{ 0.6,-0.5, 0.5},
	{ 0.6, 0.5, 0.5},
	{-0.6, 0.5, 0.5},
	{-0.6,-0.5, 0.5},
	{-0.6,-0.5,-0.5},
	{-0.6, 0.5,-0.5},
	{ 0.6, 0.5,-0.5},
	{ 0.6,-0.5,-0.5}
}

global constant faces = {
	{1,2,3,4},
	{4,3,6,5},
	{5,6,7,8},
	{8,7,2,1},
	{3,2,7,6},
	{5,8,1,4}
}

global constant
	light_pos	= {0,0,-13,1},
	light_dir	= {0,-5,-2},
	one4f		= {1,1,1,1}

global constant possible_colors = {
	{1, 0,   0, 1},	-- Color 0 - Red
	{0, 1,   0, 1},	-- Color 1 - Green
	{0, 0,   1, 1},	-- Color 2 - Blue
	{1, 1,   0, 1},	-- Color 3 - Yellow
	{0, 1,   1, 1},	-- Color 4 - Cyan
	{1, 0,   1, 1},	-- Color 5 - Magenta
	{1, 0.5, 0, 1}	-- Color 6 - Orange
}

global constant possible_colors2 = possible_colors/2


global constant possible_colors_amb = {
	{0.5, 0,   0, 1},	-- Color 0 - Red
	{0, 0.5,   0, 1},	-- Color 1 - Green
	{0, 0,   0.5, 1},	-- Color 2 - Blue
	{0.5, 0.5,   0, 1},	-- Color 3 - Yellow
	{0, 0.5,   0.5, 1},	-- Color 4 - Cyan
	{0.5, 0,   0.5, 1},	-- Color 5 - Magenta
	{0.5, 0.25, 0, 1}	-- Color 6 - Orange
}

global constant possible_colors_spec = {
	{1, 0.4,   0.4, 1},	-- Color 0 - Red
	{0.4, 1,   0.4, 1},	-- Color 1 - Green
	{0.4, 0.4,   1, 1},	-- Color 2 - Blue
	{1, 1,   0.4, 1},	-- Color 3 - Yellow
	{0.4, 1,   1, 1},	-- Color 4 - Cyan
	{1, 0.4,   1, 1},	-- Color 5 - Magenta
	{1, 0.7, 0.4, 1}	-- Color 6 - Orange
}

global constant part_pal1 = {
	{1.0,0.5,0.25},{1.0,0.75,0.5},{1.0,1.0,0.5},{0.75,1.0,0.5},
	{0.25,1.0,0.5},{0.5,1.0,0.75},{0.5,1.0,1.0},{0.5,0.75,1.0},
	{0.5,0.5,1.0},{0.75,0.5,1.0},{1.0,0.5,1.0},{1.0,0.5,0.75}
}

-- Color-set for flashing hiscore entry (red->white)
global constant hiscore_pal = {
	{1,0,0},{1,0.25,0},{1,0.5,0},{1,0.75,0},
	{1,1,0},{1,1,0.25},{1,1,0.5},{1,1,0.75},
	{1,1,1},{1,1,1},   {1,1,1},  {1,1,1}
}

global constant shaders = {
	"None",
	"FlAt",
	"Smooth",
	"Cel",
	"Pencil sketch"
}


global sequence 
	songs,
	samples,
	midi_info,
	game_window,
	window_size,
	field,
	cur_piece,
	light_direction,
	joybtn,
	vertex_normals,
	game_modes
	
	
global atom
	font1,font2,font3,font4,
	prttex,forest,pane,
	titlescreen_display_cb,
	titlescreen_reshape_cb,
	titlescreen_input_cb,
	titlescreen_spec_input_cb,
	options_restore_displayfunc,
	options_restore_reshapefunc,
	options_restore_keyboardfunc,
	options_restore_specfunc,
	options_restore_joyhandler,
	update_cb,display_cb,
	reshape_cb,keyboard_cb,
	spec_func_cb,
	idle_cb,
	hiscore_display_cb,
	hiscore_reshape_cb,
	hiscore_input_cb,
	hiscore_get_name_display_cb,
	hiscore_get_name_reshape_cb,
	hiscore_get_name_input_cb,
	hiscore_get_name_spec_input_cb,
	level_factor,
	display_lists,
	speed_factor,
	last_frame_time,
	tetrixWindow

	
global integer
	start_new_game_id,
	game_over_id,
	hiscore_update_list_id,
	draw_block_id,
	check_complete_id,
	joyhandler_id,
	options_restore_reshape_id,
	score,
	level,
	lines,
	paused,
	rendering_mode,
	end_game,
	no_explosions,
	next_piece,
	game_music,
	master_volume,
	song_tempo,
	music_enabled,
	sound_enabled,
	stack_height,
	has_joypad,
	display_mode,
	in_game_mode
		
	
	

