include globals.e
include font.e
include utils.e


constant
	OPTION_SHADER = 1,
	OPTION_VOLUME = 2,
	OPTION_DISPLAY = 3,
	OPTION_RESUME = 4,
	OPTION_QUIT = 5,
	NUM_OPTIONS = OPTION_QUIT
	
sequence option_list
integer options_col,options_dcol,options_selection,display_mode_temp
atom options_colchange,options_input_cb,options_spec_input_cb


function options_display()
	atom t,y

	t = time()
	speed_factor = (t-last_frame_time)/0.01667
	last_frame_time = t
	
	c_proc(glClear,{GL_COLOR_BUFFER_BIT + GL_DEPTH_BUFFER_BIT})

	-- (Supposed to) draw a black->blue gradient, which for some reason doesn't show up..
	--c_proc(glShadeModel,{GL_SMOOTH})
	--c_proc(glBegin,{GL_QUADS})
	--	c_proc(glColor3f,{1,0,0})
	--	c_proc(glVertex3f,{-1,-1,-1.1})
	--	c_proc(glVertex3f,{1,-1,-1.1})
	--	c_proc(glColor3f,{0,0,1})
	--	c_proc(glVertex3f,{1,1,0})
	--	c_proc(glVertex3f,{-1,1,0})
	--c_proc(glEnd,{})

	c_proc(glEnable,{GL_TEXTURE_2D})
	c_proc(glColor4f,{0.9,0.6,0.1,1})
	putsxyz("Options:",font4,{-0.37,0.85,-1.1},16,{0.1,0.09},0.085)

	-- Draw the options strings
	y = 0.5
	for i=1 to NUM_OPTIONS do
		if (i=options_selection) then
			c_proc(glColor3f,hiscore_pal[options_col])
		else
			c_proc(glColor4f,{0.4,0.5,1,1})
		end if
		putsxyz(option_list[i],font4,{-0.85,y,-1.1},16,{0.08,0.09},0.072)
		y -= 0.15
	end for

	if options_selection=OPTION_DISPLAY then
		c_proc(glColor3f,{0.4,0.9,0.3})
		putsxyz("Select A mode from the list",font4,{-0.75,-0.72,-1.1},16,{0.06,0.06},0.055)
		putsxyz("And press Return to confirm",font4,{-0.75,-0.80,-1.1},16,{0.06,0.06},0.055)
	end if
	
	c_proc(glutSwapBuffers,{})

	-- Update the color
	options_colchange -= speed_factor --1
	if (options_colchange<=0) then
		options_col += options_dcol
		if ((options_col=1) or (options_col=12)) then
			options_dcol = -options_dcol
		end if
		options_colchange = 2.0
	end if

	return 0
end function
constant options_display_cb = call_back(routine_id("options_display"))



function options_reshape(integer w, integer h)
	game_window = {w,h}
	c_proc(glViewport,{0,0,w,h})
	return 0
end function
constant options_reshape_cb = call_back(routine_id("options_reshape"))



procedure hjoy_options()
	integer v
	atom t
	
	if joybtn[1]=-1 then
		if (options_selection=1) then
			if (rendering_mode>0) then
				rendering_mode -= 1
				option_list[1] = "ShAder: "&shaders[rendering_mode+1]
			end if
		elsif (options_selection=2) then
			if (master_volume>=327) then
				master_volume -= 327
				option_list[2] = sprintf("MAster Volume: %d%%",floor((master_volume*100)/32768))
				SetMasterVolume(floor((master_volume*100)/32768))
			end if
		end if
	elsif joybtn[1]=1 then
		if (options_selection=1) then
			if (rendering_mode<4) then
				rendering_mode += 1
				option_list[1] = "ShAder: "&shaders[rendering_mode+1]
			end if
		elsif (options_selection=2) then
			if (master_volume<65000) then
				master_volume += 327
				option_list[2] = sprintf("MAster Volume: %d%%",floor((master_volume*100)/32768))
				SetMasterVolume(floor((master_volume*100)/32768))
			end if

		end if
	elsif joybtn[2]=-1 then
		if (options_selection>1) then
			options_selection -= 1
		end if

	elsif joybtn[2]=1 then
		if (options_selection<4) then
			options_selection += 1
		end if	
	end if

	if joybtn[3] or joybtn[4] then
		if options_selection=3 then
			-- Resume
			c_proc(glutKeyboardFunc,{options_restore_keyboardfunc})
			c_proc(glutSpecialFunc,{options_restore_specfunc})
			c_proc(glutReshapeFunc,{options_restore_reshapefunc})
			c_proc(glutDisplayFunc,{options_restore_displayfunc})
			joyhandler_id = options_restore_joyhandler
		elsif options_selection=4 then
			if (music_enabled) then
				for i=1 to length(songs) do
					if atom(songs[i]) then
						StopMod(songs[i])
					end if
				end for
				sample_play(samples[8])
				t = time()
				while time()-t<1.514 do
				end while
				CloseSoundSystem()
			end if
			if in_game_mode then
				c_proc(glutLeaveGameMode,{})
			end if
			abort(0)
		end if
	end if
end procedure
constant hjoy_options_id = routine_id("hjoy_options")



function options_input(integer key_code,atom x,atom y)
	atom t
	
	key_code = and_bits(key_code,#FF)	-- BUGFIX 2003-06-20
	
	if key_code=13 then
		if options_selection=OPTION_DISPLAY then
			if display_mode_temp!=display_mode then
				if display_mode_temp=1 then
					-- Don't draw anything for now
					c_proc(glutDisplayFunc,{null_cb})
					c_proc(glutIdleFunc,{null_cb})
					
					-- Leave game mode
					c_proc(glutLeaveGameMode,{})
					
					c_proc(glutSetWindow,{tetrixWindow})
					
					in_game_mode = 0
					display_mode = 1
					game_window = window_size
					
					if upload_texture({font1}) then end if
					if upload_texture({font4}) then end if
					if upload_texture({prttex}) then end if
					if upload_texture({pane}) then end if
					if upload_texture({forest}) then end if
					compile_lists()
					
					c_proc(glutDisplayFunc,{options_display_cb})
					c_proc(glutIdleFunc,{idle_cb})
				else
					if set_video_mode(display_mode_temp-1) then
						if not in_game_mode then
							window_size = game_window
						end if
						in_game_mode = 1
						compile_lists()
						display_mode = display_mode_temp
						game_window = {c_func(glutGameModeGet,{GLUT_GAME_MODE_WIDTH}),
						               c_func(glutGameModeGet,{GLUT_GAME_MODE_HEIGHT})}
	
						c_proc(glMatrixMode,{GL_PROJECTION})
						c_proc(glLoadIdentity,{})
						c_proc(glFrustum,{-1, 1, -1, 1, 1.1, 20})
						c_proc(gluLookAt,{0, 0, 0,	-- Pos. of camera
						   		 0, 0, -5,	-- Look at
						   		 0, 1, 0})	-- Normalvector
						c_proc(glMatrixMode,{GL_MODELVIEW})
						c_proc(glLoadIdentity,{})
						c_proc(glHint,{GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST})
						c_proc(glEnable,{GL_DEPTH_TEST})

						-- Textures need to be re-uploaded after switching resolution
						if upload_texture({font1}) then end if
						if upload_texture({font4}) then end if
						if upload_texture({prttex}) then end if
						if upload_texture({pane}) then end if
						if upload_texture({forest}) then end if
					
						-- Re-register all callbacks	
						c_proc(glutReshapeFunc,{options_reshape_cb})
						c_proc(glutDisplayFunc,{options_display_cb})
						c_proc(glutSpecialFunc,{options_spec_input_cb})
						c_proc(glutKeyboardFunc,{options_input_cb})
						c_proc(glutIdleFunc,{idle_cb})
						
						if options_reshape(game_window[1],game_window[2]) then end if
					end if
				end if
			end if
			
		elsif options_selection=OPTION_RESUME then
			c_proc(glutKeyboardFunc,{options_restore_keyboardfunc})
			c_proc(glutSpecialFunc,{options_restore_specfunc})
			c_proc(glutReshapeFunc,{options_restore_reshapefunc})
			c_proc(glutDisplayFunc,{options_restore_displayfunc})
			joyhandler_id = options_restore_joyhandler
			if options_restore_reshape_id then
				if call_func(options_restore_reshape_id,game_window) then
				end if
				options_restore_reshape_id = 0
			end if
		
		elsif options_selection=OPTION_QUIT then
			end_game = 1
			if (music_enabled) then
				for i=1 to length(songs) do
					if atom(songs[i]) then
						StopMod(songs[i])
					end if
				end for
				sample_play(samples[8])
				t = time()
				while time()-t<1.514 do
				end while
				CloseSoundSystem()
			end if
			if in_game_mode then
				c_proc(glutLeaveGameMode,{})
			end if
			c_proc(glutDisplayFunc,{0})
			c_proc(glutIdleFunc,{0})
			gl_deleteTextures(3,{font1,font4})
			free_textures()
			abort(0)
		end if
	end if
	
	return 0
end function
options_input_cb = call_back(routine_id("options_input"))



function options_spec_input(integer key_code,atom x, atom y)
	integer i

	if key_code=GLUT_KEY_UP then
		if (options_selection>1) then
			options_selection -= 1
		end if
		
	elsif key_code=GLUT_KEY_DOWN then
		if (options_selection<OPTION_QUIT) then
			options_selection += 1
		end if
		
	elsif key_code=GLUT_KEY_RIGHT then
		if (options_selection=OPTION_SHADER) then
			if (rendering_mode<4) then
				rendering_mode += 1
				option_list[OPTION_SHADER] = "ShAder: "&shaders[rendering_mode+1]
			end if
		elsif (options_selection=OPTION_VOLUME) then
			if (master_volume<65000) then
				master_volume += 327
				option_list[OPTION_VOLUME] = sprintf("MAster Volume: %d%%",floor((master_volume*100)/32768))
				SetMasterVolume(floor((master_volume*100)/32768))
			end if

		elsif (options_selection=OPTION_DISPLAY) then
			if (display_mode_temp<length(game_modes)+1) then
				option_list[OPTION_DISPLAY] = "DisplAy mode: "&game_modes[display_mode_temp]
				display_mode_temp += 1
			end if				
		end if
		
	elsif key_code=GLUT_KEY_LEFT then
		if (options_selection=1) then
			if (rendering_mode>0) then
				rendering_mode -= 1
				option_list[1] = "ShAder: "&shaders[rendering_mode+1]
			end if
		elsif (options_selection=OPTION_VOLUME) then
			if (master_volume>=327) then
				master_volume -= 327
				option_list[OPTION_VOLUME] = sprintf("MAster Volume: %d%%",floor((master_volume*100)/32768))
				SetMasterVolume(floor((master_volume*100)/32768))
			end if
		elsif (options_selection=OPTION_DISPLAY) then
			if display_mode_temp>1 then
				display_mode_temp -= 1
				if display_mode_temp=1 then
					option_list[OPTION_DISPLAY] = "DisplAy mode: Windowed"
				else
					option_list[OPTION_DISPLAY] = "DisplAy mode: "&game_modes[display_mode_temp-1]
				end if
			end if				
		end if
	end if

	return 0
end function
options_spec_input_cb = call_back(routine_id("options_spec_input"))



global procedure options()
	c_proc(glMatrixMode,{GL_PROJECTION})
	c_proc(glLoadIdentity,{})
	c_proc(glFrustum,{-1, 1, -1, 1, 1.1, 20})
	c_proc(gluLookAt,{0, 0, 0,	-- Pos. of camera
	   		 0, 0, -5,	-- Look at
	   		 0, 1, 0})	-- Normalvector
	c_proc(glMatrixMode,{GL_MODELVIEW})
	c_proc(glLoadIdentity,{})
	c_proc(glHint,{GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST})

	options_col = 1
	options_colchange = 2
	options_dcol = 1
	options_selection = 1
	option_list = {"","","","Resume","Quit"}
	if display_mode=1 then
		option_list[OPTION_DISPLAY] = "DisplAy mode: Windowed"
	else
		option_list[OPTION_DISPLAY] = "DisplAy mode: "&game_modes[display_mode-1]
	end if
	display_mode_temp = display_mode

	option_list[OPTION_SHADER] = "ShAder: "&shaders[rendering_mode+1]
	option_list[OPTION_VOLUME] = sprintf("MAster Volume: %d%%",floor((master_volume*100)/32768))
	
	c_proc(glutReshapeFunc,{options_reshape_cb})
	c_proc(glutDisplayFunc,{options_display_cb})
	c_proc(glutSpecialFunc,{options_spec_input_cb})
	c_proc(glutKeyboardFunc,{options_input_cb})
	joyhandler_id = hjoy_options_id
	if options_reshape(game_window[1],game_window[2]) then end if
end procedure

options_restore_joyhandler = 0

