include glue.e

global constant
	ALIVE = 1,
	LIFE = 2,
	FADE = 3,
	COL = 4,
	POS = 5,
	DIR = 6,
	GRAVITY = 7

global constant new_particle = {0,0,0,{0,0,0},{0,0,0},{0,0,0},{0,0,0}}


function bury(sequence p)
	p[ALIVE] = 0
	return p
end function
global constant bury_id = routine_id("bury")


-- Draw a number of particles and return true if there are any live particles left.
global function draw_particles(sequence p,integer num,integer t,atom zoom,atom resistance,atom size,atom threshold,integer pr)
	atom x,y,z
	integer any_alive
	sequence pi
	
	any_alive = 0
	
	c_proc(glEnable,{GL_TEXTURE_2D})
	c_proc(glBindTexture,{GL_TEXTURE_2D,t})

	c_proc(glEnable,{GL_BLEND})
	c_proc(glBlendFunc,{GL_SRC_ALPHA,GL_ONE})

	for i=1 to num do
		if (p[i][ALIVE]) then
			any_alive = 1
			pi = p[i]
			
			x = pi[POS][1]
			y = pi[POS][2]
			z = pi[POS][3]+zoom

			-- Use the life value as alpha
			c_proc(glColor4f,pi[COL]&pi[LIFE])

			-- Draw a quad as a triangle strip
			c_proc(glBegin,{GL_TRIANGLE_STRIP})
				c_proc(glTexCoord2f,{1.0, 0.0})
				c_proc(glVertex3f,{x+size, y+size, z})
				c_proc(glTexCoord2f,{0.0, 0.0})
				c_proc(glVertex3f,{x-size, y+size, z})
				c_proc(glTexCoord2f,{1.0, 1.0})
				c_proc(glVertex3f,{x+size, y-size, z})
				c_proc(glTexCoord2f,{0.0, 1.0})
				c_proc(glVertex3f,{x-size, y-size, z})
			c_proc(glEnd,{})

			-- Update the position
			pi[POS] += pi[DIR]*speed_factor/resistance
			
			-- Update the direction (or speed)
			pi[DIR] += pi[GRAVITY]*speed_factor

			pi[LIFE] -= pi[FADE]*speed_factor
			if (pi[LIFE] < threshold) then
				pi = call_func(pr,{pi})
			end if
			
			p[i] = pi
		end if
	end for
	c_proc(glDisable,{GL_BLEND})
	c_proc(glDisable,{GL_TEXTURE_2D})
	return {any_alive,p}
end function

