include bmp.e
include glue.e

global constant DISCARD_MEMORY = 1

constant textureIDPtr = allocate(4)

sequence texture_table
texture_table = {{},{}}



global procedure free_textures()
	for i=1 to length(texture_table[2]) do
		free(texture_table[2][i][1])
	end for
end procedure


global function upload_texture(sequence t)
	integer id,p

	if length(t)=1 then
		p = find(t[1],texture_table[1])
		if p>0 then
			id = t[1]
			gl_deleteTextures(1,{id})
			t = texture_table[2][p]
		end if
	else
		c_proc(glGenTextures,{1,textureIDPtr})
		id = peek4u(textureIDPtr)
	end if
	
	if t[HEIGHT] = 1 then
		c_proc(glBindTexture,{GL_TEXTURE_1D,id})
		c_proc(glTexParameteri,{GL_TEXTURE_1D, GL_TEXTURE_MAG_FILTER, GL_NEAREST})
		c_proc(glTexParameteri,{GL_TEXTURE_1D, GL_TEXTURE_MIN_FILTER, GL_NEAREST})
		c_proc(glTexEnvi,{GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE})
		if t[BITCOUNT] = 24 then
			c_proc(glTexImage1D,{GL_TEXTURE_1D, 0, GL_RGB,
			                     t[WIDTH], 0, GL_RGB,
			                     GL_UNSIGNED_BYTE, t[POINTER]})
		elsif t[BITCOUNT] = 32 then
			c_proc(glTexImage1D,{GL_TEXTURE_1D, 0, 4,
			                     t[WIDTH], 0, GL_RGBA,
			                     GL_UNSIGNED_BYTE, t[POINTER]})
		end if
	else
		c_proc(glBindTexture,{GL_TEXTURE_2D,id})
		c_proc(glTexParameteri,{GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR})
		c_proc(glTexParameteri,{GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR})
		c_proc(glTexEnvi,{GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE})
		if t[BITCOUNT] = 24 then
			c_proc(glTexImage2D,{GL_TEXTURE_2D, 0, GL_RGB,
			                     t[WIDTH], t[HEIGHT], 0, GL_RGB,
			                     GL_UNSIGNED_BYTE, t[POINTER]})
		elsif t[BITCOUNT] = 32 then
			c_proc(glTexImage2D,{GL_TEXTURE_2D, 0, 4, 
					     t[WIDTH], t[HEIGHT], 0,
					     GL_RGBA, GL_UNSIGNED_BYTE, 
					     t[POINTER]})
		end if
	end if

	--free(t[POINTER])
	
	return id
end function



-- Create a texture from the .bmp file specified by 'filename'. 
global function texture(sequence args)
	sequence t
	integer tid,save_tentry
	
	t = load_bmp(args[1])
	if t[1]=0 then
		puts(1,"Unable to load texture: "&args[1])
		abort(0)
	end if
	if length(args)>=4 then
		t = add_alpha_channel(t,args[2..4])
		if t[1]=0 then
			puts(1,"Unable to load texture: "&args[1])
			abort(0)
		end if		
	end if
	
	tid = upload_texture(t)
	save_tentry = 1
	if length(args)=2 or length(args)=5 then
		if args[length(args)]=DISCARD_MEMORY then
			free(t[1])
			save_tentry = 0
		end if
	end if
	if save_tentry then
		texture_table[1] = append(texture_table[1],tid)
		texture_table[2] = append(texture_table[2],t)
	end if
	return tid
end function


