include glue.e
include globals.e


global function set_video_mode(integer mode)
	glut_gameModeString(game_modes[mode])
	if c_func(glutEnterGameMode,{}) then
	end if
	if c_func(glutGameModeGet,{GLUT_GAME_MODE_DISPLAY_CHANGED}) then
		--in_game_mode = 1
		return 1
	end if
	return 0
end function


global procedure compile_lists()
	if display_lists != -1 then
		c_proc(glDeleteLists,{display_lists,1})
	end if
	display_lists = c_func(glGenLists,{1})
	
	c_proc(glNewList,{display_lists,GL_COMPILE})

  	c_proc(glBegin,{GL_QUADS})
		-- Front
		c_proc(glVertex3f,vertexes[1])
		c_proc(glVertex3f,vertexes[2])
		c_proc(glVertex3f,vertexes[3])
		c_proc(glVertex3f,vertexes[4])

		-- Left
		c_proc(glVertex3f,vertexes[4])
		c_proc(glVertex3f,vertexes[3])
		c_proc(glVertex3f,vertexes[6])
		c_proc(glVertex3f,vertexes[5])

		-- Back
		c_proc(glVertex3f,vertexes[5])
		c_proc(glVertex3f,vertexes[6])
		c_proc(glVertex3f,vertexes[7])
		c_proc(glVertex3f,vertexes[8])

		-- Right
		c_proc(glVertex3f,vertexes[8])
		c_proc(glVertex3f,vertexes[7])
		c_proc(glVertex3f,vertexes[2])
		c_proc(glVertex3f,vertexes[1])

		-- Top
		c_proc(glVertex3f,vertexes[3])
		c_proc(glVertex3f,vertexes[2])
		c_proc(glVertex3f,vertexes[7])
		c_proc(glVertex3f,vertexes[6])

		-- Bottom
		c_proc(glVertex3f,vertexes[5])
		c_proc(glVertex3f,vertexes[8])
		c_proc(glVertex3f,vertexes[1])
		c_proc(glVertex3f,vertexes[4])

  	c_proc(glEnd,{})
  	
	c_proc(glEndList,{})
end procedure
  
	

global function null_function()
	return 0
end function
global constant null_cb = call_back(routine_id("null_function"))


global function fabs(atom a)
	if a<0 then
		return -a
	end if
	return a
end function


-- Calculate the dot product of u and v
global function dot(sequence u, sequence v)
	return u[1]*v[1] + u[2]*v[2] + u[3]*v[3]
end function



-- Return the unit vector of v
global function normalize(sequence v)
	atom len
	
	len = sqrt(v[1]*v[1] + v[2]*v[2] + v[3]*v[3])
	if len=0.0 then
		len = 1.0
	end if
	
	return v/len
end function